unit Style;
{$I utils.inc}
interface

uses {$IFNDEF CLX_} Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls,
     {$ELSE} QGraphics, QForms, QControls, QStdCtrls, QButtons, QExtCtrls, {$ENDIF}
     SysUtils, Classes, MarkChse, PenChse, FrameGrp;

type
  TStyleDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Lbl: TLabel;
    FittedPenChoose: TPenChoose;
    DataMarkChoose: TMarkChoose;
    HideFitted: TCheckBox;
    HideData: TCheckBox;
    ApplyButton: TButton;
    DataName: TEdit;
    DataAsLine: TCheckBox;
    FittedAsLine: TCheckBox;
    DataPenChoose: TPenChoose;
    FittedMarkChoose: TMarkChoose;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var AAction: TCloseAction);
    procedure ApplyButtonClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DataAsLineClick(Sender: TObject);
    procedure FittedAsLineClick(Sender: TObject);
  public
    DataChild: TForm;
  end;

var
  StyleDlg: TStyleDlg;

implementation

uses BaseDataC;

{$IFNDEF LCL_}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TStyleDlg.FormDestroy(Sender: TObject);
begin
  if DataChild is TBaseDataChild then
    TBaseDataChild(DataChild).StyleDlg := nil;
end;

procedure TStyleDlg.FittedAsLineClick(Sender: TObject);
begin
  if FittedAsLine.Checked then begin
    if FittedPenChoose.Visible then
      Exit;
    FittedMarkChoose.Visible := False;
    FittedPenChoose.Visible := True;
    FittedPenChoose.LineStyle.Colour := FittedMarkChoose.MarkStyle.Colour;
  end else begin
    if FittedMarkChoose.Visible then
      Exit;
    FittedPenChoose.Visible := False;
    FittedMarkChoose.Visible := True;
    with FittedPenChoose do begin
      FittedMarkChoose.SetBounds(Left, Top, Width, Height);
      FittedMarkChoose.MarkStyle.Colour := LineStyle.Colour;
    end;
  end;
  HideFitted.BringToFront;
  FittedAsLine.BringToFront;
end;

procedure TStyleDlg.FormClose(Sender: TObject; var AAction: TCloseAction);
begin
  AAction := caFree;
end;

procedure TStyleDlg.ApplyButtonClick(Sender: TObject);
begin
  if DataChild is TBaseDataChild then
    TBaseDataChild(DataChild).UnloadStyleOptions;
end;

procedure TStyleDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TStyleDlg.DataAsLineClick(Sender: TObject);
begin
  if DataAsLine.Checked then begin
    if DataPenChoose.Visible then
      Exit;
    DataMarkChoose.Visible := False;
    DataPenChoose.Visible := True;
    with DataMarkChoose do begin
      DataPenChoose.SetBounds(Left, Top, Width, Height);
      DataPenChoose.LineStyle.Colour := MarkStyle.Colour;
    end;
  end else begin
    if DataMarkChoose.Visible then
      Exit;
    DataPenChoose.Visible := False;
    DataMarkChoose.Visible := True;
    DataMarkChoose.MarkStyle.Colour := DataPenChoose.LineStyle.Colour;
  end;
  HideData.BringToFront;
  DataAsLine.BringToFront;
end;

procedure TStyleDlg.OKBtnClick(Sender: TObject);
begin
  ApplyButtonClick(Sender);
  Close;
end;

end.
