unit ConstFrm;
{$I utils.inc}{Copyright (C) 2005 C M Western; see commandline.pas for license}
interface

uses
  {$IFDEF MSWINDOWS} Windows, Messages, {$ENDIF} ChildForm, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, NGrid, Mixture, ExtCtrls, StdCtrls, ComCtrls,
  Split, Menus, Buttons, GridEx, MNode, Settings, ScrlCtrl, LogControl, EditLog;

type

  TConstantsForm = class;

  TMNodeHelper = class
  private
    FConstantsForm: TConstantsForm;
  public
    constructor Create(Form: TConstantsForm);
    procedure ParameterChanged(MNode: TMNode; Index: Integer); virtual;
    procedure SetupGrid(MNode: TMNode); virtual;
    procedure SetWidths; virtual;
    procedure ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean); virtual;
    procedure ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean); virtual;
    procedure ParGridChanged(Col, Row: Integer); virtual;
    procedure UpdateAction; virtual;
    procedure ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean); virtual;
    function  ExtraParRows: Integer; virtual;
    property  ConstantsForm: TConstantsForm read FConstantsForm;
  end;

  TOnNodeBoolean = procedure (Flag: Boolean) of object;
  TOnNodeDoubleBoolean = procedure (Scale: Double; Flag: Boolean) of object;

  { TConstantsForm }

  TConstantsForm = class(TChildForm)
    AllMatrixElementsItem: TMenuItem;
    CopyWithLabelsItem: TMenuItem;
    RemoveParameterItem: TMenuItem;
    RemoveAllParametersItem: TMenuItem;
    Panel: TPanel;
    ParGrid: TNumberGrid;
    ActiveObject: TComboBox;
    OptGrid: TStringGridEx;
    TreeView: TTreeView;
    SplitL: TSplit;
    SplitR: TSplit;
    TreePopupMenu: TPopupMenu;
    RenameItem: TMenuItem;
    FixAllButton: TSpeedButton;
    ConvertUnitsButton: TSpeedButton;
    CopyItem: TMenuItem;
    DeleteItem: TMenuItem;
    PasteItem: TMenuItem;
    StatusBar: TStatusBar;
    UnitsLabel: TLabel;
    ValuePanel: TPanel;
    CommentPanel: TPanel;
    CommentLabel: TLabel;
    CommentEdit: TEdit;
    MoveUpItem: TMenuItem;
    MoveDownItem: TMenuItem;
    CopyWithLinkedItemsItem: TMenuItem;
    SelectPanel: TPanel;
    AddNewItem: TMenuItem;
    ConvertItem: TMenuItem;
    ParPopupMenu: TPopupMenu;
    CopyParItem: TMenuItem;
    PasteParItem: TMenuItem;
    EditParItem: TMenuItem;
    CutParItem: TMenuItem;
    ClearParItem: TMenuItem;
    MatrixElementsItem: TMenuItem;
    ConverttoPerturbationItem: TMenuItem;
    AddAllLevelsItem: TMenuItem;
    SymmetryTableItem: TMenuItem;
    OptPopupMenu: TPopupMenu;
    OptEditItem: TMenuItem;
    OptCutItem: TMenuItem;
    OptCopyItem: TMenuItem;
    OptCopyWithLabelsItem: TMenuItem;
    OptPasteItem: TMenuItem;
    OptClearItem: TMenuItem;
    AddAllLevelsTreeItem: TMenuItem;
    ShowFullNameItem: TMenuItem;
    TurnonMouseAdjustItem: TMenuItem;
    AbortMouseAdjustItem: TMenuItem;
    FixPopupMenu: TPopupMenu;
    FixAllItem: TMenuItem;
    FloatallnonZeroItem: TMenuItem;
    SetAllIncrementsItem: TMenuItem;
    ClearAllIncrementsItem: TMenuItem;
    ExpressionMemo: TEditLog;
    ExporttoCSVItem: TMenuItem;
    CSVSaveDialog: TSaveDialog;
    procedure CopyWithLabelsItemClick(Sender: TObject);
    procedure ParGridChangeCellQuery(Sender: TObject; Col, Row: Integer; var CanChange: Boolean);
    procedure AddAllLevelsItemClick(Sender: TObject);
    procedure ConverttoPerturbationItemClick(Sender: TObject);
    procedure AllMatrixElementsItemClick(Sender: TObject);
    procedure MatrixElementsItemClick(Sender: TObject);
    procedure RemoveAllParametersItemClick(Sender: TObject);
    procedure RemoveParameterItemClick(Sender: TObject);
    procedure TreeViewCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ClearParItemClick(Sender: TObject);
    procedure ParPopupMenuPopup(Sender: TObject);
    procedure EditParItemClick(Sender: TObject);
    procedure PasteParItemClick(Sender: TObject);
    procedure CutParItemClick(Sender: TObject);
    procedure CopyParItemClick(Sender: TObject);
    procedure ConvertItemClick(Sender: TObject);
    procedure AddNewItemClick(Sender: TObject);
    procedure OptGridDblClick(Sender: TObject);
    procedure OptGridMouseDown(Sender: TOBject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OptGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure ParGridExit(Sender: TObject);
    procedure ParGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure ParGridGetCellIsFlag(Sender: TObject; Col, Row: Integer; var IsFlag: Boolean);
    procedure ParGridDblClick(Sender: TObject);
    procedure ParGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ParGridChanged(Sender: TObject; Col, Row: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode; var S: String);
    procedure RenameItemClick(Sender: TObject);
    procedure OptGridSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
    procedure FixAllButtonClick(Sender: TObject);
    procedure ConvertUnitsButtonClick(Sender: TObject);
    procedure OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer; var Style: TEditStyle);
    procedure OptGridGetPickListItems(ACol, ARow: Integer; Items: TStrings);
    procedure CopyItemClick(Sender: TObject);
    procedure TreePopupMenuPopup(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure DeleteItemClick(Sender: TObject);
    procedure TreeViewEditing(Sender: TObject; Node: TTreeNode; var AllowEdit: Boolean);
    procedure TreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TreeViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure CommentEditChange(Sender: TObject);
    procedure MoveUpItemClick(Sender: TObject);
    procedure MoveDownItemClick(Sender: TObject);
    procedure CopyWithLinkedItemsItemClick(Sender: TObject);
    procedure SymmetryTableItemClick(Sender: TObject);
    procedure OptPopupMenuPopup(Sender: TObject);
    procedure OptCutItemClick(Sender: TObject);
    procedure OptCopyItemClick(Sender: TObject);
    procedure OptCopyWithLabelsItemClick(Sender: TObject);
    procedure OptPasteItemClick(Sender: TObject);
    procedure OptEditItemClick(Sender: TObject);
    procedure OptClearItemClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ShowFullNameItemClick(Sender: TObject);
    procedure ParGridMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure AddParameterItemClick(Sender: TObject);
    procedure ParGridDrawCellContents(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState; var Drawn: Boolean);
    procedure TurnonMouseAdjustItemClick(Sender: TObject);
    procedure AbortMouseAdjustItemClick(Sender: TObject);
    procedure OptGridEnter(Sender: TObject);
    procedure ParGridEnter(Sender: TObject);
    procedure FixAllItemClick(Sender: TObject);
    procedure FloatallnonZeroItemClick(Sender: TObject);
    procedure SetAllIncrementsItemClick(Sender: TObject);
    procedure ClearAllIncrementsItemClick(Sender: TObject);
    procedure TreeViewDblClick(Sender: TObject);
    procedure ExpressionMemoChange(Sender: TObject);
    procedure ExpressionMemoOnNewPopupMenu(Sender: TObject; APopupMenu: TPopupMenu);
    procedure ExporttoCSVItemClick(Sender: TObject);
  private
    LastCell: TPoint;
    LastError: string;
    LastRow: Integer; { of error }
    nInitialTreeMenuItems, nInitialParMenuItems: Integer;
    WheelAdjustActive: Boolean;
    WheelCount: Integer;
    LastBoldRow: Integer; { To ensure correct re-painting of mouse adjustable cell }
    LastAdjustedRow: Integer;
    LastAdjustedValue: Double;
    CommentLabelTop: Integer;
    {$IFDEF LCL_}
    TurnOnEditing: Boolean;
    procedure TreeViewSelectionChanged(Sender: TObject);
    {$ENDIF}
    {$IFDEF VCL_}
    procedure WMHelp(var Message: TWMHelp); message WM_HELP;
    {$ENDIF}
    procedure CopyItemsToClipboard(LinkedItems: Boolean);
  protected
    SelectorComboBoxTop, SelectorComboBoxLeft, MarginSize: Integer; { Helpers for window flip logic }
    MNodeHelper, CorrelationsHelper, InterpolatedPartitionFunctionHelper, TableHelper: TMNodeHelper;
    procedure MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer); override;
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SettingChanged(MNode: TMNode; Index: Integer); override;
    procedure PropNameChanged(MNode: TMNode; Index: Integer); override;
    function StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer; override;
    procedure CheckForNameChange;
    procedure UpdateActions; override;
    procedure HandleControl(Control: TControl; var PName, Value, PHint: string; var Save: Boolean; var SettingType: TSettingType; Write: Boolean); override;
    procedure EmptyParGrid;
    procedure SetCommentOrExpr(IsComment: Boolean; const S: string);
    { Helper functions to hide TreeView multiselect differences }
    function SelectedNode(Index:Integer):TMNode;
    function MoveUpDown(Shift: Integer; Test: Boolean):Boolean; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CanReStuff:Boolean; override;
    procedure AdjustSplitters; virtual;
    function BaseNodeClass: TClass; override;
    procedure ShowItem(MNode: TMNode); override;
    procedure StuffSelector(MNode: TMNode); override;
    function DefaultCaption: string; virtual;
    procedure UpdateAlwaysVisible(Force: Boolean); virtual;
    function PasteItemsIntoTree: Boolean;
    procedure FlipOrientation;
    procedure ArrangeForm(Screen: TRect); override;
    function MNodeFromTreeNode(TreeNode: TTreeNode): TMNode;
    function Helper(MNode: TMNode = nil):TMNodeHelper;
    procedure ForAllSelectedNodes(OnBool: TOnNodeBoolean; OnNodeDoubleBoolean: TOnNodeDoubleBoolean; Scale: Double; Flag: Boolean);
  end;

var
  ConstantsForm: TConstantsForm;

implementation

uses {$IFDEF LCL_} LResources, LCLType, LCLIntf, {$ENDIF}
     Global, Constrain, MNodeColour, WCompat, MNodeClip, Overlay, OvrlyFrm,
     ClipBrd, RenForm, Units, WhatsThis, PropHelp, LogUnit, Math,
     Expr, MatrixElements, Profile, QuantumNumber, CalSource, Main, Worker,
     SettingsForm, Types, Vib, pgXMLWrite, Contnrs, MathSup,
     LineFrm, PartFunc, MNodeExpr, FitControlFrm;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

{ TMNodeHelper }

constructor TMNodeHelper.Create(Form: TConstantsForm);
begin
  FConstantsForm := Form;
end;

function TMNodeHelper.ExtraParRows: Integer;
begin
  Result := 0;
end;

procedure TMNodeHelper.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  with ConstantsForm do
    if MNode = CurrentMNode then begin
      if Index >= ParGrid.RowCount then
        Exit;
      ParGrid.Lbl[Index] := MNode.ParameterNames[Index];
      ParGrid[Index,1] := MNode.Parameters[Index];
      if MNode is TStringMNode then
        { Skip }
      else begin
        ParGrid.Valid[Index,2] := MNode.Floating[Index];
        if MNode.Increment[Index] <= 0 then
          ParGrid.Valid[Index,3] := False
        else
          ParGrid[Index,3] := MNode.Increment[Index];
        if MNode.StdDev[Index] <= 0 then
          ParGrid.Valid[Index,4] := False
        else
          ParGrid[Index,4] := MNode.StdDev[Index];
      end;
    end;
end;

procedure TMNodeHelper.ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean);
begin
  { Do not allow number of rows and columns to change }
  with ConstantsForm do
    CanChange := CanChange and (ParGrid.FixedRows > 0)
                 and (Row < ParGrid.RowCount) and (Col < ParGrid.ColCount);
end;

procedure TMNodeHelper.ParGridChanged(Col, Row: Integer);
begin
  with ConstantsForm do
    if Assigned(CurrentMNode) and (Row > 0) then
      case Col of
        1: CurrentMNode.SetParameter(Row, ParGrid[Row, Col]);
        2: CurrentMNode.Floating[Row] := ParGrid.Valid[Row, Col];
        3: if ParGrid.Valid[Row, Col] and (ParGrid[Row, Col] > 0) then
             CurrentMNode.Increment[Row] := ParGrid[Row, Col]
           else begin
             CurrentMNode.Increment[Row] := 0;
             ParGrid.Valid[Row,Col] := False;
           end;
        4: if ParGrid.Valid[Row, Col] and (ParGrid[Row, Col] > 0) then
             CurrentMNode.StdDev[Row] := ParGrid[Row, Col]
           else begin
             CurrentMNode.StdDev[Row] := 0;
             ParGrid.Valid[Row,Col] := False;
           end;
      end;

end;

procedure TMNodeHelper.ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean);
begin
  IsFlag := (Col = 2);
end;

procedure TMNodeHelper.ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean);
begin
  with ConstantsForm do
    if Assigned(CurrentMNode) then
      case ACol of
        1: StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnParameter(ARow);
        2: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Allow parameter to float in least squares fits';
        3: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Increment to use for numerical derivatives in least squares fits (blank for default)';
        4: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Standard Deviation of parameter from last fit';
      end;
end;

procedure TMNodeHelper.SetupGrid(MNode: TMNode);
var
  i: Integer;
begin
 { Order is important here }
  with ConstantsForm do begin
    if MNode.nParameters > 0 then begin
      ParGrid.Enabled := True;
      ParGrid.RowCount := MNode.nParameters+1;
      ParGrid.FixedRows := 1;
      if MNode is TStringMNode then
        ParGrid.ColCount := 2
      else begin
        ParGrid.ColCount := 5;
        ParGrid.Title[1] := 'Value';
        ParGrid.Title[2] := 'Float';
        ParGrid.Title[3] := 'Increment';
        ParGrid.Title[4] := 'StdDev';
        if MNode is TManifold then
          ParGrid.Title[0] := 'J Sym #'
        else
          ParGrid.Title[0] := '';
      end;
    end else
      EmptyParGrid;
    CurrentMNode := MNode;
    for i := 1 to MNode.nParameters do
      ParameterChanged(MNode, i);
  end;
end;

procedure TMNodeHelper.SetWidths;
var
  i: Integer;
begin
  with ConstantsForm do begin
    ParGrid.ColWidths[0] := OptGrid.ColWidths[0];
    ParGrid.ColWidths[1] := OptGrid.ColWidths[1];
    ParGrid.AutoAdjustColumn(0,True);
    for i := 2 to ParGrid.ColCount-1 do
      ParGrid.AutoAdjustColumn(i);
  end;
end;

procedure TMNodeHelper.UpdateAction;
begin
  {}
end;

type

  TCorrelationsHelper = class(TMNodeHelper)
    procedure UpdateCorrelation(Correlations: TCorrelations);
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SetupGrid(MNode: TMNode); override;
    procedure SetWidths; override;
    procedure ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean); override;
    procedure ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean); override;
    procedure ParGridChanged(Col, Row: Integer); override;
    procedure UpdateAction; override;
    procedure ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean); override;
  end;

  TInterpolatedPartitionFunctionHelper = class(TMNodeHelper)
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SetupGrid(MNode: TMNode); override;
    procedure SetWidths; override;
    procedure ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean); override;
    procedure ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean); override;
    procedure ParGridChanged(Col, Row: Integer); override;
    procedure UpdateAction; override;
    procedure ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean); override;
    function  ExtraParRows: Integer; override;
  end;

  TTableHelper = class(TMNodeHelper)
    procedure UpdateTable(Table: TTable);
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SetupGrid(MNode: TMNode); override;
    procedure SetWidths; override;
    procedure ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean); override;
    procedure ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean); override;
    procedure ParGridChanged(Col, Row: Integer); override;
    procedure UpdateAction; override;
    procedure ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean); override;
  end;

{ TConstantsForm }

procedure TConstantsForm.StuffSelector(MNode: TMNode);
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  try
    inherited;
  except
    on E: Exception do
      StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
  end;
  if Assigned(MNode) and (csDestroying in MNode.ComponentState) then
    MNode := nil;
  BeginGlobalUpdate;
  try
    ActiveObject.Clear;
    ActiveObject.OnChange := {$IFDEF FPC}@{$ENDIF}ComboBoxChange;
    TreeView.Items.Clear;
    Stuff(MNode, '', nil);
    UpdateComboBox(ActiveObject);
    FComboBoxUpdated := False;
  finally
    EndGlobalUpdate(False);
  end;
  TreeView.FullExpand;
  ComboBoxChange(ActiveObject);
  UpdateAlwaysVisible(True);
end;

procedure TConstantsForm.SymmetryTableItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  for i := 0 to TreeView.SelectionCount - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TState then
      with MNode as TState do begin
        Molecule.Mixture.CheckProperties;
        SymmetryTable(Log);
      end;
  end;
end;

function TConstantsForm.Helper(MNode: TMNode = nil): TMNodeHelper;
begin
  if not Assigned(MNode) then
    MNode := CurrentMnode;
  if MNode is TCorrelations then begin
    if not Assigned(CorrelationsHelper) then
      CorrelationsHelper := TCorrelationsHelper.Create(Self);
    Result := CorrelationsHelper;
  end else if MNode is TInterpolatedPartitionFunction then begin
    if not Assigned(InterpolatedPartitionFunctionHelper) then
      InterpolatedPartitionFunctionHelper := TInterpolatedPartitionFunctionHelper.Create(Self);
    Result := InterpolatedPartitionFunctionHelper;
  end else if MNode is TTable then begin
    if not Assigned(TableHelper) then
      TableHelper := TTableHelper.Create(Self);
    Result := TableHelper;
  end else begin
    if not Assigned(MNodeHelper) then
      MNodeHelper := TMNodeHelper.Create(Self);
    Result := MNodeHelper;
  end;
end;

procedure TConstantsForm.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  Helper.ParameterChanged(MNode, Index);
end;

procedure TConstantsForm.SettingChanged(MNode: TMNode; Index: Integer);
var
  s: string;
begin
  if OptGrid.EditorMode then Exit;
  if MNode = CurrentMNode then begin
    OptGrid.Cells[0,Index-1] := MNode.SettingNames[Index];
    s := MNode.SettingToStr(Index);
    if MNode.IsSettingQuantum(Index) and (s[1] in ['-', '0'..'9']) then
      s := GlobalMixture.QuantumNumberToStr(MNode.Settings[Index]);
    OptGrid.Cells[1,Index-1] := s;
  end;
  CheckForNameChange;
end;

procedure TConstantsForm.ShowItem(MNode: TMNode);
var
  i: Integer;
  procedure EmptyOptGrid;
  begin
    with OptGrid do begin
      FixedRows := 0;
      RowCount := 1;
      Cells[0,0] := '';
      Cells[1,0] := '';
    end;
  end;
var
  TreeNode: TTreeNode;
  NewCaption: string;
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  if Assigned(CurrentMNode) and (LastError <> '') then begin
    MessageDlg(LastError, mtError, [mbOK], 0);
    LastError := '';
    ShowItem(CurrentMNode);
    OptGrid.Row := LastRow;
    Exit;
  end;
  LastError := '';
  CurrentMNode := nil; { Lockout change notifications }
  NewCaption := DefaultCaption;
  if MNode = nil then begin
    EmptyParGrid;
    with ParGrid do begin
      FixedRows := 0;
      RowCount := 1;
    end;
    EmptyOptGrid;
    {$IFDEF LCL_}
    TreeView.Selected := nil;
    {$ELSE}
    TreeView.Select([]);
    {$ENDIF}
    CommentEdit.Text := '';
    ExpressionMemo.Clear;
  end else begin
    SetCommentOrExpr(not (MNode is TMNodeExpr), MNode.Comment);
    TreeNode := FindObject(TreeView,MNode);
    {$IFDEF LCL_}
    TreeView.Selected := TreeNode;
    {$ELSE}
    if TreeView.Selected <> TreeNode then
      TreeView.Select(TreeNode);
    {$ENDIF}
    TreeNode.MakeVisible;
    Helper(MNode).SetupGrid(MNode);
    if MNode.nSettings < 1 then
      EmptyOptGrid
    else begin
      OptGrid.RowCount := MNode.nSettings;
      for i := 1 to MNode.nSettings do
        SettingChanged(MNode, i);
      OptGrid.FixedRows := 0;
    end;
    SetItemIndex(ActiveObject,MNode);
    OptGrid.ColWidths[0] := OptGrid.DefaultColWidth;
    OptGrid.AutoAdjustColumn(0,True);
    Helper.SetWidths;
    NewCaption := CurrentMNode.Name + ' - ' + NewCaption;
  end;
  Caption := NewCaption;
  UpdateAlwaysVisible(True);
  AdjustSplitters;
end;

procedure TConstantsForm.ParGridGetCellIsFlag(Sender: TObject; Col, Row: Integer; var IsFlag: Boolean);
begin
  Helper.ParGridGetCellIsFlag(Col, Row, IsFlag);
end;

procedure TConstantsForm.ParGridDblClick(Sender: TObject);
begin
  if (LastCell.Y > 0) and (LastCell.Y < ParGrid.RowCount) then
    {$IFDEF LCL}
    if LastCell.X > 0 then
      TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
    {$ENDIF}
end;

procedure TConstantsForm.ParGridDrawCellContents(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState; var Drawn: Boolean);
begin
  if WheelAdjustActive and (ACol = 1) and (ARow = ParGrid.Row) then begin
    ParGrid.Canvas.Font.Style := [fsBold];
    LastBoldRow := ARow;
  end else
    ParGrid.Canvas.Font.Style := [];
end;

procedure TConstantsForm.ParGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ParGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.AbortMouseAdjustItemClick(Sender: TObject);
begin
  WheelAdjustActive := False;
  if LastAdjustedRow > 0 then begin
    ParGrid.Value[ParGrid.Row, 1] := LastAdjustedValue;
    MainForm.ConsiderReplot;
  end;
  LastAdjustedRow := -1;
end;

procedure TConstantsForm.ParGridMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  Increment: Double;
begin
  if WheelAdjustActive and (ParGrid.Row > 0) then begin
    Inc(WheelCount, WheelDelta);
    Handled := True;
    if CalculationInProgress then begin
      { Defer }
    end else begin
      if LastAdjustedRow <> ParGrid.Row then begin
        LastAdjustedRow := ParGrid.Row;
        LastAdjustedValue := ParGrid.Value[ParGrid.Row,1];
      end;
      if ParGrid.Valid[ParGrid.Row,3] then
        Increment := ParGrid.Value[ParGrid.Row,3]
      else
        Increment := ParGrid.Value[ParGrid.Row,1] * 0.01;
      if Increment = 0 then
        Increment := 0.1;
      if Abs(WheelCount) >= WHEEL_DELTA then
        Increment := Increment * (Abs(WheelCount) div WHEEL_DELTA);
      if WheelCount < 0 then
        Increment := -Increment;
      ParGrid.Value[ParGrid.Row, 1] := ParGrid.Value[ParGrid.Row, 1] + Increment;
      WheelCount := 0;
      MainForm.ConsiderReplot;
    end;
  end;
end;

procedure TConstantsForm.ParGridChangeCellQuery(Sender: TObject; Col,
  Row: Integer; var CanChange: Boolean);
begin
  Helper.ParGridChangeCellQuery(Col, Row, CanChange);
end;

procedure TConstantsForm.CopyWithLabelsItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard(True);
end;

procedure TConstantsForm.ParGridChanged(Sender: TObject; Col, Row: Integer);
begin
  Helper.ParGridChanged(Col, Row);
end;

procedure TConstantsForm.FormCreate(Sender: TObject);
begin
  {$IFDEF LCL_}
  ParGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  OptGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  TreeView.OnSelectionChanged := @TreeViewSelectionChanged;
  StatusBar.SimplePanel := False;
  FixAllButton.Flat := False;
  ConvertUnitsButton.Flat := False;
  {$ENDIF}
  ParGrid.OnGetCellIsFlag := {$IFDEF FPC}@{$ENDIF}ParGridGetCellIsFlag;
  ExpressionMemo.OnNewPopupMenu := {$IFDEF FPC}@{$ENDIF}ExpressionMemoOnNewPopupMenu;
end;

procedure TConstantsForm.FormDestroy(Sender: TObject);
begin
  if ConstantsForm = Self then
    ConstantsForm := nil;
end;

procedure TConstantsForm.FormHide(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  OptGrid.EditorMode := False;
end;

procedure TConstantsForm.FormResize(Sender: TObject);
begin
  if SplitL.Align in [alLeft, alRight] then begin
    if  Height > Width *1.2 then
      FlipOrientation;
  end else if Width > Height*1.2 then
    FlipOrientation;
  AdjustSplitters;
//  SplitL.ParentResized;
//  SplitR.ParentResized;
  {$IFDEF LCL_}
  //AlControl(nil);
  //AlControl(CommentLabel);
  //AlControl(CommentEdit);
  {$ENDIF}
end;

procedure TConstantsForm.HandleControl(Control: TControl; var PName, Value,
  PHint: string; var Save: Boolean; var SettingType: TSettingType; Write: Boolean);
begin
  if Control = ActiveObject then
    inherited;
end;

function TConstantsForm.SelectedNode(Index: Integer): TMNode;
var
  Node: TTreeNode;
  {$IFDEF VCL_}
  i: Integer;
  {$ENDIF}
begin
  Result := nil;
  {$IFDEF VCL_}
  // Can't use Node := TreeView.Selections[Index]; as order depends on how selection made
  Node := nil;
  for i := 0 to TreeView.Items.Count-1 do
    if TreeView.Items[i].Selected then begin
      Dec(Index);
      if Index < 0 then begin
        Node := TreeView.Items[i];
        Break;
      end;
    end;
  {$ELSE}
  Node := TreeView.GetFirstMultiSelected;
  if not Assigned(Node) and (Index = 0) then begin
    Result := CurrentMNode;
    Exit;
  end else
    while (Index > 0) and Assigned(Node) do begin
      Dec(Index);
      Node := Node.GetNextMultiSelected;
    end;
  {$ENDIF}
  if Assigned(Node) then
    Result := MNodeFromTreeNode(Node);
end;

procedure TConstantsForm.TreeViewChange(Sender: TObject; Node: TTreeNode);
var
  MNode: TMNode;
begin
  MNode := MNodeFromTreeNode(Node);
  CheckForNameChange;
  ShowItem(MNode);
end;

procedure TConstantsForm.TreeViewCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
var
  MNode: TMNode;
  Colour: TColor;
begin
  MNode := MNodeFromTreeNode(Node);
  if Assigned(MNode) and not (cdsSelected in State) then begin
    Colour := clNone;
    { TODO: sensible class method for this }
    if MNode is TState then
      Colour := TState(MNode).Colour
    else if MNode is TTransitionMoments then
      Colour := TTransitionMoments(MNode).Colour
    else if MNode is TMolecule then
      Colour := TMolecule(MNode).Colour
    else if MNode is TManifold then
      Colour := TManifold(MNode).Colour
    else if MNode is TSpecies then
      Colour := TSpecies(MNode).Colour
    else if MNode is TPlot then
      Colour := TPlot(MNode).Colour;
    if IsVisibleColour(Colour) then
      TreeView.Canvas.Font.Color := Colour
    else
      TreeView.Canvas.Font.Color := clBlack;
  end;
end;

procedure TConstantsForm.TreeViewDblClick(Sender: TObject);
var
  i: Integer;
begin
  if not Assigned(CurrentMNode) then
    Exit;
  TreePopupMenuPopup(Self);
  for i := TreePopupMenu.Items.Count - 1 downto 1 do
    if Pos('...', TreePopupMenu.Items[i].Caption) > 2 then begin
      TreePopupMenu.Items[i].OnClick(TreePopupMenu.Items[i]);
      Exit;
    end;
end;

{$IFDEF LCL_}
procedure TConstantsForm.TreeViewSelectionChanged(Sender: TObject);
begin
  TreeViewChange(Sender, TreeView.Selected);
end;
{$ENDIF}

procedure TConstantsForm.TreeViewEdited(Sender: TObject; Node: TTreeNode; var S: String);
var
  OldName: string;
begin
  CurrentMNode := MNodeFromTreeNode(Node);
  if not Assigned(CurrentMNode) then
    Exit;
  S := Trim(S);
  OldName := CurrentMNode.Name;
  BeginGlobalUpdate;
  try
    CurrentMNode.Name := S;
    RenameForm.RenameMNodePairsAsRequired(CurrentMNode.RootNode, False);
    LineForm.ConsiderRename(CurrentMNode, OldName);
  finally
    EndUpdate(False, True);
  end;
end;

procedure TConstantsForm.RenameItemClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    if CurrentMNode is TMNodePair then
      RenameForm.Rename(CurrentMNode as TMNodePair)
    else begin
      TreeView.Selected.EditText;
    end;
end;

procedure TConstantsForm.OptGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  Q: TQuantumNumber;
begin
  if Assigned(CurrentMNode) and (ACol = 1) and (Trim(OptGrid.Cells[ACol, ARow]) <> '') then
    try
      LastError := '';
      try
        BeginGlobalUpdate;
        if CurrentMNode.IsSettingQuantum(ARow+1)
           and TryStrToQuantumNumber(OptGrid.Cells[ACol, ARow], Q, GlobalMixture.QuantumNumberFormat) then
          CurrentMNode.Settings[ARow+1] := Q
        else if CurrentMNode.IsSettingColour(ARow+1) then
          CurrentMNode.Settings[ARow+1] := StrToColour(Value,True) { Prompt for colour if Other... }
        else
          CurrentMNode.SetSettingFromStr(ARow+1, OptGrid.Cells[ACol, ARow]);
        if Pos('...', Value) > 0 then
          OptGrid.Cells[ACol, ARow] := CurrentMNode.SettingToStr(ARow+1);
      finally
        EndGlobalUpdate;
      end;
    except
      on E: Exception do begin
        LastRow := ARow;
        LastError := E.Message;
        StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
      end;
    end;
end;

procedure TConstantsForm.FixAllButtonClick(Sender: TObject);
begin
  FixPopupMenu.PopupComponent := FixAllButton;
  FixPopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TConstantsForm.SetCommentOrExpr(IsComment: Boolean; const S: string);
begin
  if CommentLabelTop = 0 then
    CommentLabelTop := CommentLabel.Top;
  DisableAlign;
  if IsComment then begin
    ExpressionMemo.Visible := False;
    CommentLabel.Caption := '&Comment:';
    CommentLabel.Top := CommentLabelTop;
    CommentEdit.Visible := True;
    CommentPanel.Height := 2*CommentEdit.Top + CommentEdit.Height;
    CommentEdit.Text := S;
  end else begin
    CommentEdit.Visible := False;
    CommentLabel.Caption := 'E&xpression:';
    CommentLabel.Top := 0;
    ExpressionMemo.Visible := True;
    ExpressionMemo.Top := CommentLabel.Top + CommentLabel.Height + CommentLabel.Left;
    ExpressionMemo.Left := CommentLabel.Left;
    ExpressionMemo.Width := CommentPanel.Width - 2*CommentLabel.Left;
    ExpressionMemo.Anchors := [akLeft, akRight, akTop];
    CommentPanel.Height := ExpressionMemo.Top + ExpressionMemo.Height + + CommentLabel.Left;
    ExpressionMemo.Lines.Text := S; { TODO: Convert line endings }
  end;
  EnableAlign;
end;

procedure TConstantsForm.ForAllSelectedNodes(OnBool: TOnNodeBoolean; OnNodeDoubleBoolean: TOnNodeDoubleBoolean; Scale: Double; Flag: Boolean);
var
  i: Integer;
begin
  for i := 0 to TreeView.SelectionCount - 1 do
    if Assigned(OnBool) then begin
      TMethod(OnBool).Data := SelectedNode(i);
      OnBool(Flag);
    end else begin
      TMethod(OnNodeDoubleBoolean).Data := SelectedNode(i);
      OnNodeDoubleBoolean(Scale, Flag);
    end;
end;

procedure TConstantsForm.FixAllItemClick(Sender: TObject);
begin
  FitControlForm.Setup(BaseNode, CurrentMNode, 'Fix all Parameters in:');
  case FitControlForm.ShowModal of
    mrYes: BaseNode.FixAll(True); { Global }
    mrOK:  ForAllSelectedNodes({$IFDEF FPC}@{$ENDIF}CurrentMNode.FixAll, nil, 0, False) ; { Current }
    mrNo:  ForAllSelectedNodes({$IFDEF FPC}@{$ENDIF}CurrentMNode.FixAll, nil, 0, True); { Current and Below }
  end;
end;

procedure TConstantsForm.FloatallnonZeroItemClick(Sender: TObject);
begin
  FitControlForm.Setup(nil, CurrentMNode, 'Float all non-zero parameters in:');
  case FitControlForm.ShowModal of
    mrOK:  ForAllSelectedNodes({$IFDEF FPC}@{$ENDIF}CurrentMNode.FloatAllNonZero, nil, 0, False); { Current }
    mrNo:  ForAllSelectedNodes({$IFDEF FPC}@{$ENDIF}CurrentMNode.FloatAllNonZero, nil, 0, True); { Current and Below }
  end;
end;

procedure TConstantsForm.ClearAllIncrementsItemClick(Sender: TObject);
begin
  FitControlForm.Setup(BaseNode, CurrentMNode, 'Clear all increments in:');
  case FitControlForm.ShowModal of
    mrYes: BaseNode.SetIncrements(0,True); { Global }
    mrOK:  ForAllSelectedNodes(nil, {$IFDEF FPC}@{$ENDIF}CurrentMNode.SetIncrements, 0, False); { Current }
    mrNo:  ForAllSelectedNodes(nil, {$IFDEF FPC}@{$ENDIF}CurrentMNode.SetIncrements, 0, True); { Current and Below }
  end;
end;

procedure TConstantsForm.SetAllIncrementsItemClick(Sender: TObject);
begin
  FitControlForm.Setup(BaseNode, nil, 'Set all increments in:');
  case FitControlForm.ShowModal of
    mrYes: BaseNode.SetIncrements(FitControlForm.Scale,True); { Global }
    mrOK:  ForAllSelectedNodes(nil, {$IFDEF FPC}@{$ENDIF}CurrentMNode.SetIncrements, FitControlForm.Scale, False); { Current }
    mrNo:  ForAllSelectedNodes(nil, {$IFDEF FPC}@{$ENDIF}CurrentMNode.SetIncrements, FitControlForm.Scale, True); { Current and Below }
  end;
end;

procedure TConstantsForm.FlipOrientation;
  function ShiftCon(Control: TControl):Integer;
  begin
    if akLeft in Control.Anchors then begin
      Control.Anchors := (Control.Anchors - [akLeft]) + [akRight];
      Result := Control.Left;
    end else begin
      Control.Anchors := (Control.Anchors - [akRight]) + [akLeft];
      Result := Control.Left + Control.Width;
    end;
  end;
var
  W, NewTop: Integer;
begin
  Panel.DisableAlign;
  if SplitL.Align in [alLeft, alRight] then begin
    { Switch to narrow form - controls in panel in two lines }
    NewTop := 2*SelectorComboBoxTop + ActiveObject.Height;
    Panel.Height := NewTop + ActiveObject.Height + SelectorComboBoxTop;
    Panel.Top := 0;
    ActiveObject.Top := 2*SelectorComboBoxTop + ActiveObject.Height;
    ActiveObject.Width := Panel.Width - 2*MarginSize;
    ActiveObject.Left := MarginSize;
    FixAllButton.Left := SelectorComboBoxLeft;
    ConvertUnitsButton.Left := ShiftCon(FixAllButton);
    UnitsLabel.Left := ShiftCon(ConvertUnitsButton) + 4;
    ShiftCon(UnitsLabel);
  end else begin
    { Switch to wide form - controls in panel in one line};
    UnitsLabel.Left := Panel.Width-MarginSize-UnitsLabel.Width;
    ConvertUnitsButton.Left := ShiftCon(UnitsLabel)-MarginSize-ConvertUnitsButton.Width;
    FixAllButton.Left := ShiftCon(ConvertUnitsButton)-FixAllButton.Width;
    ShiftCon(FixAllButton);
    ActiveObject.Top := SelectorComboBoxTop;
    ActiveObject.Left := SelectorComboBoxLeft;
    ActiveObject.Width := FixAllButton.Left - ActiveObject.Left - MarginSize;
    Panel.Height := ActiveObject.Top + ActiveObject.Height + SelectorComboBoxTop;
  end;
  Panel.EnableAlign;
  if SplitL.Align in [alLeft, alRight] then begin
    W := TreeView.Height;
    Constraints.MinHeight := 300;
  end else begin
    W := TreeView.Width;
    Constraints.MinHeight := 200;
  end;
  SplitL.Flip(W div 3, 2 * W div 3);
  SplitR.Flip(2 * W div 3);
end;

function TConstantsForm.DefaultCaption: string;
begin
  Result := 'Constants';
end;

procedure TConstantsForm.ConvertUnitsButtonClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then begin
    FormDeactivate(nil);
    CurrentMNode.CycleUnits;
  end;
end;

procedure TConstantsForm.OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer; var Style: TEditStyle);
begin
  if Assigned(CurrentMNode) and CurrentMNode.IsSettingEnum(ARow+1) then
    Style := esPickList;
end;

procedure TConstantsForm.OptGridGetPickListItems(ACol, ARow: Integer; Items: TStrings);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.GetEnumNames(ARow+1, Items);
end;

procedure TConstantsForm.CopyItemClick(Sender: TObject);
begin
  CopyItemsToClipboard(False);
end;

procedure TConstantsForm.CopyItemsToClipboard(LinkedItems: Boolean);
var
  i: Integer;
  MNodeList: TObjectList;
begin
  if TreeView.SelectionCount > 1 then begin
    { Prepare list of items to put on the clipboard }
    MNodeList := TObjectList.Create(False);
    try
      for i := 0 to TreeView.SelectionCount - 1 do
        if LinkedItems then
          SelectedNode(i).LinkedNodesList(MNodeList)
        else
          MNodeList.Add(SelectedNode(i));
      SelectedNode(0).CopyToClipboard(True,MNodeList);
    finally
      MNodeList.Free;
    end;
  end else if Assigned(CurrentMNode) then
    CurrentMNode.CopyToClipboard(LinkedItems);
end;

procedure TConstantsForm.CopyWithLinkedItemsItemClick(Sender: TObject);
begin
  CopyItemsToClipboard(True);
end;

{ Helper }
procedure ResetMenu(var nInitialItems: Integer; Menu: TPopupMenu);
begin
  with Menu.Items do begin
    if nInitialItems = 0 then
      nInitialItems := Count;
    while Count > nInitialItems do
      Delete(Count-1);
  end;
end;

procedure TConstantsForm.TreePopupMenuPopup(Sender: TObject);
var
  i, nCT: Integer;
  MenuItem: TMenuItem;
  GlobalSetting, Linked: Boolean;
  MNodeClass: TMNodeClass;
  procedure CheckNode(MNode: TMNode);
  begin
    GlobalSetting := GlobalSetting or ((MNode is TNucleus) or (MNode is TBaseVibrationalMode));
    Linked := Linked or (MNode.LinkedNodesList > 0);
  end;
begin
  if Assigned(TreeView.Selected) then
    TreeView.Selected.Selected := True;
  GlobalSetting := False;
  Linked := False;
  if TreeView.SelectionCount > 1 then
    for i := 0 to TreeView.SelectionCount - 1 do
      CheckNode(SelectedNode(i))
  else if Assigned(CurrentMNode) then
    CheckNode(CurrentMNode);
  CopyWithLinkedItemsItem.Visible := Assigned(CurrentMNode) and not GlobalSetting and Linked;
  PasteItem.Enabled := Clipboard.HasFormat(MNodeClipboardFormat);
  MoveUpItem.Enabled := MoveUpDown(-1,True);
  MoveDownItem.Enabled := MoveUpDown(+1,True);
  ConvertItem.Visible := (CurrentMNode is TState) or (CurrentMNode is TNucleus);
  DeleteItem.Enabled := not GlobalSetting;
  AllMatrixElementsItem.Visible := (CurrentMNode is TState) or (CurrentMNode is TPerturbation) or (CurrentMNode is TTransitionMoment) or (CurrentMNode is TNucleus);
  SymmetryTableItem.Visible := CurrentMNode is TState;
  AddAllLevelsTreeItem.Visible := (CurrentMNode is TManifold) or (CurrentMNode is TState);
  nCT := 0;
  if Assigned(CurrentMNode) then
    for i := 0 to CurrentMNode.nChildTypes-1 do
      if CurrentMNode.GetChildTypes(i) <> nil then
        Inc(nCT);
  if nCT > 0 then begin
    AddNewItem.Enabled := True;
    AddNewItem.Clear;
    if nCT > 1 then begin
      AddNewItem.Caption := '&Add new ...';
      AddNewItem.Tag := -1;
      for i := 0 to CurrentMNode.nChildTypes-1 do begin
        MNodeClass := CurrentMNode.GetChildTypes(i);
        if Assigned(MNodeClass) and CurrentMNode.IsValidChildClass(MNodeClass)
           and not MNodeClass.InheritsFrom(TFormSettings)
           and (not MNodeClass.InheritsFrom(TPlot) or MNodeClass.InheritsFrom(TCalculatedSource)) then begin
          MenuItem := TMenuItem.Create(AddNewItem);
          MenuItem.Caption := MNodeClass.DisplayClassName;
          MenuItem.Hint := 'Add new object'; { TODO: Make F1 work }
          MenuItem.Tag := i;
          MenuItem.OnClick := {$IFDEF FPC}@{$ENDIF}AddNewItemClick;
          AddNewItem.Add(MenuItem);
        end;
      end;
      if CurrentMNode is TOverlays then
        StuffCalibrationMenu(AddNewItem,{$IFDEF FPC}@{$ENDIF}MainForm.I2ItemClick);
    end else begin
      for i := 0 to CurrentMNode.nChildTypes-1 do begin
        MNodeClass := CurrentMNode.GetChildTypes(i);
        if Assigned(MNodeClass) then begin
          AddNewItem.Tag := i;
          AddNewItem.Caption := '&Add new ' + MNodeClass.DisplayClassName;
          Break;
        end;
      end;
    end;
  end else begin
    AddNewItem.Caption := '&Add new ...';
    AddNewItem.Enabled := False;
  end;
  { Add MNode specific items }
  ResetMenu(nInitialTreeMenuItems, TreePopupMenu);
  if (TreeView.SelectionCount = 1) and Assigned(CurrentMNode) then { TODO: Implement multiple handler }
    CurrentMNode.AddHandlersToMenu(TreePopupMenu.Items);
end;

procedure TConstantsForm.PasteItemClick(Sender: TObject);
begin
  PasteItemsIntoTree;
end;

procedure TConstantsForm.DeleteItemClick(Sender: TObject);
var
  i, Ans, LinkedAns: Integer;
  DoReplot: Boolean;
  MNode, NextMNode: TMNode;
  MNodeList: TComponentList;
begin
  DoReplot := False;
  NextMNode := nil;
  MNodeList := TComponentList.Create(False);
  LinkedAns := mrNo;
  Ans := mrNo;
  BeginGlobalUpdate;
  try
    for i := TreeView.SelectionCount-1 downto 0 do begin
      MNode := SelectedNode(i);
      if MNodeList.IndexOf(MNode) < 0 then begin
        { If not already flagged for deletion }
        if MNode.LinkedNodesList > 0 then begin
          if not (LinkedAns in [mrYesToAll, mrNoToAll]) then
            LinkedAns := MessageDlg(MNode.UniqueName + ' has linked nodes. Delete these also?', mtConfirmation,
                                   [mbYes, mbYesToAll, mbNo, mbNoToAll, mbCancel],0);
          case LinkedAns of
            mrYes, mrYesToAll: MNode.LinkedNodesList(MNodeList);
            mrNo, mrNoToAll:   MNodeList.Add(MNode);
            mrCancel:          Exit;
          end;
        end else begin
          if Ans <> mrYesToAll then
            Ans := MessageDlg('Are you sure you want to delete ' + MNode.UniqueName + '?', mtConfirmation,
                              [mbYes, mbYesToAll, mbNo, mbCancel],0);
          case Ans of
            mrYes, mrYesToAll: MNodeList.Add(MNode);
            mrCancel:          Exit;
          end;
        end;
      end;
      DoReplot := DoReplot or (MNode is TPlot);
      if (MNodeList.IndexOf(MNode) >= 0) and (not Assigned(NextMNode) or (MNode.ComponentIndex > NextMNode.ComponentIndex)) then
        NextMNode := MNode; { Remember last deleted selected item }
    end;
    if Assigned(NextMNode) then begin
      MNode := NextMNode;
      NextMNode := NextMNode.Owner as TMNode;
      { Find next active node after last deleted item }
      if MNode.ComponentIndex < NextMNode.ComponentCount-1 then { Take node below }
        NextMNode := NextMNode.Components[MNode.ComponentIndex+1] as TMNode
      else if MNode.ComponentIndex > 0 then { Take node above }
        NextMNode := NextMNode.Components[MNode.ComponentIndex-1] as TMNode;
    end;
    CurrentMNode := NextMNode;
    MNodeList.OwnsObjects := True; { Force delete items in next line }
  finally
    MNodeList.Free;
    EndGlobalUpdate;
  end;
  if DoReplot then
    MainForm.ConsiderReplot;
end;

destructor TConstantsForm.Destroy;
begin
  FreeAndNil(MNodeHelper);
  FreeAndNil(CorrelationsHelper);
  FreeAndNil(InterpolatedPartitionFunctionHelper);
  inherited;
end;

function TConstantsForm.CanReStuff: Boolean;
begin
  Result := inherited CanReStuff;
  Result := Result and not ParGrid.EditorMode and not OptGrid.EditorMode;
end;

procedure TConstantsForm.TreeViewEditing(Sender: TObject; Node: TTreeNode; var AllowEdit: Boolean);
begin
  CurrentMNode := MNodeFromTreeNode(Node);
  { Only allow in place edits for standard nodes; MNodePairs must use dialog }
  AllowEdit := AllowEdit and not (CurrentMNode is TMNodePair);
end;

procedure TConstantsForm.TreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  {$IFDEF LCL_}
  if (Key in [VK_UP, VK_DOWN]) and (Shift = [ssAlt]) then begin
    { Handle here as LCL treats key as navigation key }
    MoveUpDown(IfThen(Key=VK_DOWN,1,-1),False);
    Key := VK_UNKNOWN;
  end;
  {$ENDIF}
end;

procedure TConstantsForm.TreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{$IFNDEF VCL_}
var
  Node: TTreeNode;
{$ENDIF}
begin
  if (Button = mbRight) and Assigned(TreeView.Selected) then
    {$IFDEF VCL_}
      TreeView.Selected.Selected := True
    {$ELSE}
    begin
      Node := TreeView.GetNodeAt(X,Y);
      if Assigned(Node) and not Node.Selected then
        { Other nodes possibly selected - Right click on unselected node selects only that node }
        TreeView.Items.SelectOnlyThis(Node);
    end;
    {$ENDIF}
  {$IFDEF VCL_} { VCL bug with multiple selection }
  else if (Button = mbLeft) and not (ssCtrl in Shift) and not (ssShift in Shift) then
    TreeView.ClearSelection(True)
  {$ENDIF}
end;

procedure TConstantsForm.TurnonMouseAdjustItemClick(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  WheelAdjustActive:= not WheelAdjustActive;
  LastAdjustedRow := -1;
  ParGrid.InvalidateCol(1);
end;

function TConstantsForm.BaseNodeClass: TClass;
begin
  Result := TMixture;
end;

function TConstantsForm.StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer;
begin
  ActiveObject.AddItem(Name1 + Name2, MNode);
  Result := ActiveObject.Items.Count-1;
  {$IFDEF LCL_}
  ParentNode := TreeView.Items.AddChildObject(ParentNode, Name2, MNode);
  {$ELSE}
  ParentNode := TreeView.Items.AddNode(nil, ParentNode, Name2, MNode, naAddChild);
  {$ENDIF}
end;

procedure TConstantsForm.CheckForNameChange;
begin
  if Visible and Assigned(CurrentMNode) and  (CurrentMNode.UniqueName <> CurrentMNodeName) then
    ReStuff;
end;

{$IFDEF LCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;
{$ENDIF}
procedure TConstantsForm.UpdateActions;
begin
  inherited UpdateActions;
  if Visible and not (ParGrid.EditorMode or OptGrid.EditorMode) then begin
    CheckForNameChange;
    Helper.UpdateAction;
    {$IFDEF LCL_}
    if TurnOnEditing and ((ActiveControl = ParGrid) or (ActiveControl = OptGrid)) then
      TOpenCustomGrid(ActiveControl).EditorMode := True;
    {$ENDIF}
  end;
  {$IFDEF LCL_}
  TurnOnEditing := False;
  {$ENDIF}
end;

procedure TConstantsForm.FormDeactivate(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  OptGrid.EditorMode := False;
end;

procedure TConstantsForm.PropNameChanged(MNode: TMNode; Index: Integer);
var
  i: Integer;
begin
  if MNode <> CurrentMNode then
    Exit;
  if Lockout > 0 then begin
    ReStuff;
    Exit;
  end;
  for i := 1 to CurrentMNode.nSettings do
    if OptGrid.Cells[0,i-1] <> MNode.SettingNames[i] then
       OptGrid.Cells[0,i-1] := MNode.SettingNames[i];
  if ParGrid.RowCount <> MNode.nParameters+1+Helper(MNode).ExtraParRows then
    ShowItem(MNode)
  else
    for i := 1 to MNode.nParameters do
      if ParGrid.Lbl[i] <> MNode.ParameterNames[i] then
        ParGrid.Lbl[i] := MNode.ParameterNames[i];
end;

procedure TConstantsForm.CommentEditChange(Sender: TObject);
begin
  if Assigned(CurrentMNode) and CommentEdit.Visible then
    try
      BeginGlobalUpdate;
      CurrentMNode.Comment := CommentEdit.Text;
    finally
      EndGlobalUpdate;
    end;
end;

procedure TConstantsForm.ExporttoCSVItemClick(Sender: TObject);
var
  f: System.Text;
  MNodes: TComponentList;
  MNode: TMNode;
  i, j: Integer;
  procedure Add(Node: TComponent);
  begin
    if Node = CurrentMNode then
      Exit
    else
      MNodes.Add(Node);
  end;
  function CSVQuote(s: string):string;
  begin
    if (Pos('"', s) > 0) or (Pos(',',s) > 0) then
      Result := AnsiQuotedStr(s, '"')
    else
      Result := s;
  end;
begin
  if not Assigned(CurrentMNode) or not CSVSaveDialog.Execute then
    Exit;
  MNodes := TComponentList.Create(False);
  MNodes.Add(CurrentMNode);
  try
    if TreeView.SelectionCount = 1 then begin
      MNode := CurrentMNode.Owner as TMNode;
      if Assigned(MNode) then begin
        for i := 0 to MNode.ComponentCount - 1 do
          if MNode.Components[i].ClassType = CurrentMNode.ClassType then
            Add(MNode.Components[i]);
      end;
    end else
      for i := 0 to TreeView.SelectionCount - 1 do
        Add(SelectedNode(i));
    AssignFile(f, CSVSaveDialog.FileName);
    Rewrite(f);
    Write(f, 'Type', ',');
    if CurrentMNode is TMNodePair then
      Write(f, 'Bra,',CurrentMNode.ClassName, ',Ket,')
    else
      Write(f, CSVQuote(CurrentMNode.ClassName), ',');
    Write(f, 'Owner', ',');
    for i := 1 to CurrentMNode.nSettings do
      Write(f, CSVQuote(CurrentMNode.SettingNames[i]),',');
    for i := 1 to CurrentMNode.nParameters do begin
      Write(f, CSVQuote(CurrentMNode.ParameterNames[i]),',');
      Write(f, CSVQuote(CurrentMNode.ParameterNames[i]+' StdDev'),',');
    end;
    WriteLn(f);
    for i := 0 to MNodes.Count - 1 do begin
      MNode := MNodes[i] as TMNode;
      Write(f, CSVQuote(MNode.ClassName), ',');
      if MNode is TMNodePair then
        with MNode as TMNodePair do
          Write(f, CSVQuote(Bra.Name), ',', CSVQuote(PairName), ',', CSVQuote(Ket.Name), ',')
      else
        Write(f, CSVQuote(MNode.Name), ',');
        Write(f, CSVQuote((MNode.Owner as TMNode).FullHeirarchicName(False,True)), ',');
      for j := 1 to MNode.nSettings do
        Write(f, CSVQuote(MNode.SettingToStr(j)),',');
      for j := 1 to MNode.nParameters do begin
        Write(f, CSVQuote(FloatToStr(MNode.Parameters[j])),',');
        if not IsNanOrInf(MNode.StdDev[j]) then
          Write(f, CSVQuote(FloatToStr(MNode.StdDev[j])));
        Write(f, ',')
      end;
      WriteLn(f);
    end;
    CloseFile(f);
  finally
    MNodes.Free;
  end;
end;

procedure TConstantsForm.ExpressionMemoChange(Sender: TObject);
begin
  if Assigned(CurrentMNode) and ExpressionMemo.Visible then
    try
      BeginGlobalUpdate;
      CurrentMNode.Comment := ExpressionMemo.Lines.Text;
    finally
      EndGlobalUpdate;
    end;
end;

procedure TConstantsForm.ExpressionMemoOnNewPopupMenu(Sender: TObject; APopupMenu: TPopupMenu);
begin
  if not Assigned(CurrentMNode) or not (CurrentMNode is TMNodeExpr) then
    Exit;
  CurrentMNode.AddHandlersToMenu(APopupMenu.Items);
end;

procedure TConstantsForm.MatrixElementsItemClick(Sender: TObject);
begin
  ReShow(LogForm);
  if CurrentMNode is TState then
    ShowMatrixElements(Log, CurrentMNode, CurrentMNode as TState, ParGrid.Selection.Top, ParGrid.Selection.Bottom, True, '')
  else if CurrentMNode is TNucleus then
    ShowMatrixElements(Log, CurrentMNode, CurrentMNode.Owner as TState, ParGrid.Selection.Top, ParGrid.Selection.Bottom, True, '');
end;

procedure TConstantsForm.ShowFullNameItemClick(Sender: TObject);
var
  s: string;
  p: Integer;
begin
  if Assigned(CurrentMNode) and (CurrentMNode.nParameters >= ParGrid.Row) and (ParGrid.Row > 0) then begin
    s := CurrentMNode.FullParameterName(ParGrid.Row);
    for p := 1 to Length(s) do
      if not (s[p] in ['A'..'Z','a'..'z','0'..'9','.','_']) then begin
        s := '"' + s + '"';
        Break;
      end;
    ShowInfo('Parameter Name is ' + s);
    Clipboard.AsText := s;
  end;
end;

procedure TConstantsForm.ConverttoPerturbationItemClick(Sender: TObject);
var
  i: Integer;
begin
  BeginGlobalUpdate;
  try
    for i := ParGrid.Selection.Top to ParGrid.Selection.Bottom do
      if CurrentMNode is TState then
        TState(CurrentMNode).ConvertParameter(i,True)
      else if CurrentMNode is TNucleus then
        TNucleus(CurrentMNode).ConvertParameter(i,True);
  finally
    EndGlobalUpdate;
  end;
end;

procedure ShowAllMatrixElements(var f: Text; MNode: TMNode; State: TState);
  procedure ShowElements(const Elements: TMatrixElements; ShowPhases: Boolean);
  var
    j, k: Integer;
  begin
    for j := 0 to High(Elements) do begin
      WriteLn(Log, State.MatrixElementType(Elements[j], 'H', ShowPhases), ' = ');
      with Elements[j].Expr do
        if Base = OperatorPlus then
          for k := 0 to nChildren-1 do
            WriteLn(Log, '+  ', Children[k].Text(True))
        else
          WriteLn(Log, '   ', Text(True))
    end;
  end;
var
  AMatrixElements, ASymmetrizedElements: TMatrixElements;
begin
  if MNode = State then begin
    State.CheckMatrixElementsAvailable(False);
    AMatrixElements := State.MatrixElements;
    ASymmetrizedElements := State.SymmetrizedMatrixElements;
  end else
    with MNode as TNucleus do begin
      CheckMatrixElementsAvailable;
      AMatrixElements := MatrixElements;
      ASymmetrizedElements := SymmetrizedMatrixElements;
    end;
  Writeln(Log, 'Matrix Elements in ',  MNode.UniqueName);
  ShowElements(AMatrixElements, False);
  if Length(ASymmetrizedElements) > 0 then begin
    Writeln(Log, 'Symmetrized Matrix Elements in ', MNode.UniqueName);
    ShowElements(ASymmetrizedElements, True);
    WriteLn(Log);
  end;
end;

procedure TConstantsForm.AllMatrixElementsItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  ReShow(LogForm);
  for i := 0 to TreeView.SelectionCount - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TPerturbation then
      with MNode as TPerturbation do begin
        Writeln(Log, 'Matrix Elements of ', Name);
        ShowSymbolicMatrixElements(Log);
      end
    else if MNode is TState then
      ShowAllMatrixElements(Log, MNode, MNode as TState)
    else if MNode is TNucleus then
      ShowAllMatrixElements(Log, MNode, MNode.Owner as TState)
    else if MNode is TTransitionMoment then
      (MNode as TTransitionMoment).ShowSymbolicMatrixElements(Log)
  end;
end;

procedure TConstantsForm.ArrangeForm(Screen: TRect);
var
  MainRect, NewRect: TRect;
begin
  inherited;
  MainRect := ScreenBounds(MainForm);
  NewRect := Rect(MainRect.Right, MainRect.Top, Screen.Right, MainRect.Bottom);
  with NewRect do
    if Right - Left < 200 then
      Left := Right - 200;
  if OverlayForm.Visible and ConstantsForm.Visible then begin
    with NewRect do
      Bottom := (Top+Bottom) div 2;
    SetScreenBounds(ConstantsForm, NewRect);
    with NewRect do begin
      Top := Bottom;
      Bottom := MainRect.Bottom;
    end;
    SetScreenBounds(OverlayForm, NewRect);
  end else
    SetScreenBounds(Self, NewRect);
end;

procedure TConstantsForm.MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer);
begin
  inherited;
  if not Visible then Exit;
  UpdateAlwaysVisible(False);
  if (Sender = CurrentMNode) and (Change = mnCommentChanged) and (Lockout <= 0) then
    ShowItem(CurrentMNode);
end;

function TConstantsForm.MNodeFromTreeNode(TreeNode: TTreeNode): TMNode;
begin
  if Assigned(TreeNode) and Assigned(BaseNode) and not (csDestroying in BaseNode.ComponentState) then
    Result := TMNode(TreeNode.Data)
  else
    Result := nil;
  if Assigned(Result) then
    if not Result.IsValidChildOf(BaseNode) or (csDestroying in Result.ComponentState) then
      Result := nil
end;

procedure TConstantsForm.UpdateAlwaysVisible(Force: Boolean);
begin
  { Special call for variable that is always visible }
  if (Force or Visible) and Assigned(BaseNode) then
    UnitsLabel.Caption := (BaseNode as TUnitsMNode).UnitsName;
end;

function TConstantsForm.MoveUpDown(Shift: Integer; Test: Boolean): Boolean;
var
  SelectedNodes: array of TMNode;
  OriginalIndex: array of Integer;
  i, j: Integer;
  Moved: Boolean;
  Node: TTreeNode;
  List: TList;
begin
  Result := False;
  SetLength(SelectedNodes,TreeView.SelectionCount);
  if Length(SelectedNodes) = 0 then
    Exit;
  SetLength(OriginalIndex,Length(SelectedNodes));
  for i := 0 to Length(SelectedNodes) - 1 do begin
    SelectedNodes[i] := SelectedNode(i);
    OriginalIndex[i] := SelectedNodes[i].ComponentIndex;
    if not SelectedNodes[i].CanShift(Shift) then
      Exit;
  end;
  Result := True;
  if Test then
    Exit;
  for j := 0 to Length(SelectedNodes) do begin
    { Repeatedly apply the shift to avoid the need to apply the shifts in order }
    Moved := False;
    for i := 0 to Length(SelectedNodes) - 1 do
      if SelectedNodes[i].ComponentIndex <> OriginalIndex[i]+Shift then begin
        SelectedNodes[i].ComponentIndex := OriginalIndex[i]+Shift;
        Moved := True;
      end;
    if not Moved then
      Break;
  end;
  ReStuff;
  { Reselect nodes }
  List := TList.Create;
  try
    Node := TreeView.Items.GetFirstNode;
    while Assigned(Node) do begin
      for i := 0 to High(SelectedNodes) do
        if SelectedNodes[i] = TMNode(Node.Data) then begin
          {$IFDEF LCL_}
          Node.MultiSelected := True;
          {$ELSE}
          List.Add(Node);
          {$ENDIF}
          Break;
        end;
      Node := Node.GetNext;
    end;
    {$IFNDEF LCL_}
    TreeView.Select(List);
    {$ENDIF}
  finally
    List.Free;
  end;
end;

procedure TConstantsForm.MoveUpItemClick(Sender: TObject);
begin
  MoveUpDown(-1,False);
end;

procedure TConstantsForm.MoveDownItemClick(Sender: TObject);
begin
  MoveUpDown(+1,False);
end;

constructor TConstantsForm.Create(AOwner: TComponent);
begin
  inherited;
  SelectorComboBoxTop := ActiveObject.Top;
  SelectorComboBoxLeft := ActiveObject.Left;
  MarginSize := ActiveObject.Left;
  {$IFNDEF VCL_}
  TreeView.ScrollBars := ssAutoBoth; { Equivalent in Delphi is not adjustable }
  TreeView.Options := TreeView.Options + [tvoAllowMultiselect];
  TreeView.RightClickSelect := False;
  {$ENDIF}
  ParGrid.OnMouseWheel := {$IFDEF FPC}@{$ENDIF}ParGridMouseWheel;
end;

{$IFDEF VCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;

procedure TConstantsForm.WMHelp(var Message: TWMHelp);
var
  InPlaceEditor: Boolean;
  function Involves(Control: TWinControl):Boolean;
  begin
    Result := True;
    InPlaceEditor := False;
    if Control.Handle <> Message.HelpInfo.hItemHandle then
      if Control.Handle <>  GetParent(Message.HelpInfo.hItemHandle) then
        Result := False { Inplace editor }
      else
        InPlaceEditor := True;
  end;
  function TryGrid(Grid: TCustomGrid):Boolean;
  var
    Point: TPoint;
    Coord: TGridCoord;
    BookMark: string;
  begin
    Result := Involves(Grid);
    if not Result then Exit;
    if InContextHelp and not InPlaceEditor then begin
      Point := Grid.ScreenToClient(Message.HelpInfo.MousePos);
      Coord := Grid.MouseCoord(Point.X, Point.Y);
    end;
    if not InContextHelp or InPlaceEditor or (Coord.Y < TOpenCustomGrid(Grid).FixedRows) or (Coord.Y > TOpenCustomGrid(Grid).RowCount) then
      Coord.Y := TOpenCustomGrid(Grid).Row;
    if Grid = ParGrid then
      BookMark := CurrentMnode.ParameterNames[Coord.Y]
    else
      BookMark := CurrentMNode.SettingNames[Coord.Y+1];
    Application.HelpSystem.ShowTopicHelp(CurrentMnode.PageName+'.htm#'
                                         +BookMark, Application.CurrentHelpFile);
  end;
  function TryTreeView(TreeView: TTreeView):Boolean;
  var
    TreeNode: TTreeNode;
    MNode: TMnode;
    Point: TPoint;
  begin
    Result := Involves(TreeView);
    MNode := nil;
    if InContextHelp then begin
      Point := TreeView.ScreenToClient(Message.HelpInfo.MousePos);
      TreeNode := TreeView.GetNodeAt(Point.X, Point.Y);
      if Assigned(TreeNode) then
        MNode := MNodeFromTreeNode(TreeNode);
    end;
    if not Assigned(MNode) then
      MNode := CurrentMNode;
    Application.HelpSystem.ShowTopicHelp(Copy(MNode.ClassType.ClassName,2,255)+'.htm',
                                         Application.CurrentHelpFile);
  end;
begin
  if InHelp then Exit;
  if not (csDesigning in ComponentState)
     and (Message.HelpInfo.iContextType = HELPINFO_WINDOW)
     and Assigned(CurrentMNode) then begin
    if TryGrid(ParGrid) or TryGrid(OptGrid) then
      Exit;
    if TryTreeView(TreeView) then
      Exit;
  end;
  inherited;
end;
{$ENDIF}

procedure TConstantsForm.ParGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
  Helper.ParGridSelectCell(ACol, ARow, CanSelect);
  if WheelAdjustActive and (ACol <> 1) and (ARow <> LastBoldRow) then
    ParGrid.InvalidateCol(1);
end;

procedure TConstantsForm.ParGridEnter(Sender: TObject);
var
  CanSelect: Boolean; { Not Used }
begin
  CanSelect := True;
  ParGridSelectCell(Sender,ParGrid.Col,ParGrid.Row, CanSelect);
end;

procedure TConstantsForm.ParGridExit(Sender: TObject);
begin
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  CheckForNameChange;
end;

procedure TConstantsForm.OptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if Assigned(CurrentMNode) then
    StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnSetting(ARow+1);
  CheckForNameChange;
end;

procedure TConstantsForm.OptGridEnter(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnSetting(OptGrid.Row+1);
end;

procedure TConstantsForm.AddAllLevelsItemClick(Sender: TObject);
var
  Manifold: TManifold;
  i: Integer;
begin
  for i := 0 to TreeView.SelectionCount - 1 do begin
    Manifold := SelectedNode(i).AncestorWithClass(TManifold) as TManifold;
    if Assigned(Manifold) then
      Manifold.AddAllLevels(CurrentMNode.AncestorWithClass(TState) as TState);
  end;
  ReStuff;
end;

procedure TConstantsForm.RemoveAllParametersItemClick(Sender: TObject);
begin
  with CurrentMNode do
    while FirstDynamicParameter <= nParameters do
      DeleteParameter(nParameters);
  ReStuff;
end;

procedure TConstantsForm.RemoveParameterItemClick(Sender: TObject);
var
  i: Integer;
begin
  BeginGlobalUpdate;
  try
    if (CurrentMNode is TManifold) or (CurrentMNode is TVariables) or (CurrentMNode is TMNodeWithExprs) then
      for i := ParGrid.Selection.Bottom downto Max(ParGrid.Selection.Top,CurrentMNode.FirstDynamicParameter) do
        CurrentMNode.DeleteParameter(i);
  finally
    EndGlobalUpdate;
  end;
end;

procedure TConstantsForm.AddParameterItemClick(Sender: TObject);
var
  s: string;
  p: Integer;
begin
  BeginGlobalUpdate;
  try
    s := '';
    if InputQuery('Add Parameters','Parameter Name(s), separated by spaces', s) then begin
      repeat
        s := Trim(s);
        if s = '' then
          Break;
        p := Pos(' ', s);
        if p > 0 then begin
          CurrentMNode.AddParameter(Copy(s,1,p-1));
          Delete(s,1,p);
        end else
          CurrentMNode.AddParameter(s);
      until p <= 0;
    end;
  finally
    EndUpdate;
  end;
end;

procedure TConstantsForm.AddNewItemClick(Sender: TObject);
var
  MNode: TMNode;
  RenameOK: Boolean;
  s: string;
  {$IFDEF LCL}
  i: Integer;
  {$ENDIF}
begin
  if Assigned(CurrentMNode) then
    with Sender as TMenuItem do
      if Tag >= 0 then begin
        BeginGlobalUpdate;
        try
          if CurrentMNode.GetChildTypes(Tag).InheritsFrom(TNucleus) then
            with (CurrentMNode as TState).Molecule do
              nNuclei := nNuclei + 1
          else if CurrentMNode.GetChildTypes(Tag).InheritsFrom(TBaseVibrationalMode) then
            with CurrentMNode.Owner.Owner as TVibratingMolecule do
              nModes := nModes + 1
          else begin
            MNode := CurrentMNode.GetChildTypes(Tag).Create(CurrentMNode);
            if not (MNode is TMNodePair) and not (MNode is TCalibrationSource) then begin
              MNode.AdjustDefaults;
              s := MNode.DefaultClassName;
              if Assigned(CurrentMNode{.RootNode}.ComponentWithName(s,TMNode,nil,True)) then
                s := 'New ' + s;
              MNode.Name := s;
            end;
            try
              RenameOK := RenameForm.RenameMNodePairsAsRequired(MNode, True);
            except
              MNode.Free;
              raise;
            end;
            if RenameOK then begin { Cancel => MNode no longer valid }
              if MNode.InheritsFrom(TSphericalTransitionMoment) then
                (MNode as TSphericalTransitionMoment).SetSettingFromStr(MNode.IndexOfSetting('Component'),'auto');
              {$IFDEF LCL}
              if MNode is TMNodePair then begin
                { LCL has problems with treeview items with identical names, so shift new node to
                  top if necessary }
                s := MNode.UniqueName;
                for i := 0 to CurrentMNode.Count-1 do
                  if (CurrentMNode.Items[i] <> MNode) and (CurrentMNode.Items[i].UniqueName = s) then begin
                    MNode.ComponentIndex := 0;
                    ReStuff;
                    Break;
                  end;
              end;
              {$ENDIF}
              CurrentMNode := MNode;
            end;
          end;
        finally
          EndGlobalUpdate;
        end;
      end;
end;

type
  TOpenGrid = class(TCustomGrid);

procedure TConstantsForm.AdjustSplitters;
var
  TreeViewSize, ParGridSize, OptGridSize: Integer;
  Available: Integer; { Total available space }
  TreeNode: TTreeNode;
  Rect: TRect;
  HasVertScrollBar, HasHorzScrollBar: Boolean;
  procedure DistributeExcess;
  var
    Excess, MinSize, i, nSmall: Integer;
    Sizes, MinSizes: array [0..2] of Integer;
  begin
    Excess := 0;
    MinSize := Available div 3;
    Sizes[0] := TreeViewSize;
    Sizes[1] := ParGridSize;
    Sizes[2] := OptGridSize;
    { First guess - divide into 3 equal parts, or smaller
      if fits }
    nSmall := 0; { Number needing less than 1/3 of space }
    for i := 0 to 2 do begin
      MinSizes[i] := Min(MinSize, Sizes[i]);
      Sizes[i] := MinSizes[i];
      if Sizes[i] < MinSize then begin
        Inc(Excess, MinSize - Sizes[i]);
        Inc(nSmall);
      end;
    end;
    { Second pass - share out excess }
    if nSmall > 0 then
      for i := 0 to 2 do begin
        if Sizes[i] = MinSize then
          Inc(Sizes[i], Excess div (3-nSmall));
      end;
    TreeViewSize := Sizes[0];
    ParGridSize := Sizes[1];
    OptGridSize := Sizes[2];
  end;
  function HeightNeeded(Grid: TCustomGrid):Integer;
  var
    i, W: Integer;
  begin
    with TOpenGrid(Grid) do begin
      Result := (DefaultRowHeight+GridLineWidth)*RowCount+GridLineWidth;
      if BorderStyle = bsSingle then
        Inc(Result,2);
      { Compute total width here, to avoid problems with appearing/disapearing scroll bars }
      W := GridLineWidth;
      for i := 0 to ColCount-1 do
        Inc(W, ColWidths[i]+GridLineWidth);
      { Assume Vertical scroll bar needed unless needs < 1/3 available space }
      if {$IFDEF LCLcarbonOFF}True or{$ENDIF} (Result > Available div 3) then
        Inc(W,GetSystemMetrics(SM_CXVSCROLL));
      if {$IFDEF LCLcarbonOFF}True or{$ENDIF} (W >= Width) then
        Inc(Result, GetSystemMetrics(SM_CYHSCROLL)); { Horizontal Scroll Bar needed }
    end;
  end;
begin
  SplitL.MakeBothVisible;
  { Establish the preferred width of all the separate items }
  if SplitL.Align in [alLeft, alRight] then begin
    { Horozontal layout }
    SplitL.MinSize := MulDiv(GetSystemMetrics(SM_CXHSCROLL),25,10);
    SplitR.MinSize := SplitL.MinSize;
    Available := SelectPanel.Width - (SplitL.Width + SplitR.Width);
    TreeViewSize := 0;
    TreeNode := TreeView.Items.GetFirstNode;
    HasVertScrollBar := Assigned(TreeNode) and (TreeNode.DisplayRect(True).Top < 0);
    Rect.Bottom := 0;
    while Assigned(TreeNode) do begin
      Rect := TreeNode.DisplayRect(True);
      TreeViewSize := Max(TreeViewSize, Rect.Right);
      TreeNode := TreeNode.GetNext;
    end;
    HasVertScrollBar := HasVertScrollBar or (Rect.Bottom > TreeView.Height);
    if {$IFDEF LCLcarbonOFF}True or{$ENDIF} HasVertScrollBar then
      Inc(TreeViewSize, GetSystemMetrics(SM_CXVSCROLL));
    Inc(TreeViewSize, TreeView.BorderWidth+4{$IFDEF LCL_}+4{$ENDIF});
    if Pargrid.ColCount > 2 then
      ParGridSize := ParGrid.NaturalWidth
    else
      ParGridSize := 0;
    OptGridSize := NaturalWidth(OptGrid);
    DistributeExcess;
    TreeView.Width := TreeViewSize;
    ValuePanel.Width := SelectPanel.Width - TreeViewSize - SplitL.Width;
    if ParGridSize > 0 then begin
      SplitR.MakeBothVisible;
      ParGrid.Width := ParGridSize;
      OptGrid.Width := OptGridSize;
    end else
      SplitR.OneWindowVisible(OptGrid);
  end else begin
    { Vertical layout }
    SplitL.MinSize := MulDiv(GetSystemMetrics(SM_CYVSCROLL),25,10);
    SplitR.MinSize := SplitL.MinSize;
    Available := SelectPanel.Height - (SplitL.Height + SplitR.Height + CommentPanel.Height);
    TreeViewSize := 0;
    TreeNode := TreeView.Items.GetFirstNode;
    HasHorzScrollBar := False;
    Rect.Bottom := 0;
    while Assigned(TreeNode) do begin
      if TreeNode.IsVisible then begin
        Rect := TreeNode.DisplayRect(True);
        HasHorzScrollBar := HasHorzScrollBar or (Rect.Left < 0) or (Rect.Right >= TreeView.Width);
        TreeViewSize := Min(TreeViewSize, Rect.Top);
      end;
      TreeNode := TreeNode.GetNext;
    end;
    TreeViewSize := Rect.Bottom - TreeViewSize;
    if {$IFDEF LCLcarbonOFF}True or{$ENDIF} HasHorzScrollBar then
      Inc(TreeViewSize, GetSystemMetrics(SM_CYHSCROLL));
    Inc(TreeViewSize, TreeView.BorderWidth+4);
    if Pargrid.ColCount > 2 then
      ParGridSize := HeightNeeded(ParGrid)
    else
      ParGridSize := 0;
    OptGridSize := HeightNeeded(OptGrid);
    DistributeExcess;
    TreeView.Height := TreeViewSize;
    ValuePanel.Height := SelectPanel.Height - TreeViewSize - SplitL.Height;
    if ParGridSize > 0 then begin
      SplitR.MakeBothVisible;
      ParGrid.Height := ParGridSize;
      OptGrid.Height := OptGridSize;
    end else
      SplitR.OneWindowVisible(OptGrid);
  end;
  if Assigned(CurrentMNode) then begin
    TreeNode := FindObject(TreeView,CurrentMNode);
    if Assigned(TreeNode) then
      TreeNode.MakeVisible;
  end;
end;

procedure TConstantsForm.OptGridDblClick(Sender: TObject);
begin
  {$IFDEF LCL}
  if LastCell.X = 1 then
    TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
  {$ENDIF}
end;

procedure TConstantsForm.OptGridMouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  OptGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.ConvertItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  if MessageDlg('Are you sure you want to convert the parameters?', mtConfirmation, mbYesNo, 0) <> mrYes then
    Exit;
  BeginGlobalUpdate;
  try
    for i := 0 to TreeView.SelectionCount - 1 do begin
      MNode := SelectedNode(i);
      if MNode is TState then
        TState(MNode).ConvertToPerturbations(False)
      else if MNode is TNucleus then
        TNucleus(MNode).ConvertToPerturbations;
    end;
  finally
    EndGlobalUpdate;
  end;
end;

function TConstantsForm.PasteItemsIntoTree: Boolean;
var
  MNode: TMNode;
begin
  BeginGlobalUpdate;
  try
    MNode := PasteXMLNodeOnto(CurrentMNode);
    Result := Assigned(MNode);
    if Result then
      CurrentMNode := Mnode;
  finally
    EndUpdate;
  end;
end;

procedure TConstantsForm.CopyParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
end;

procedure TConstantsForm.CutParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
  ParGrid.ClearSelection;
end;

procedure TConstantsForm.PasteParItemClick(Sender: TObject);
begin
  ParGrid.PasteFromClipboard;
end;

procedure TConstantsForm.EditParItemClick(Sender: TObject);
begin
  ParGrid.EditorMode := True;
end;

procedure TConstantsForm.EmptyParGrid;
begin
  with ParGrid do begin
    FixedRows := 0;
    RowCount := 1;
    ColCount := 2;
    Lbl[0] := ' ';
    Valid[0,1] := False;
  end;
end;

procedure TConstantsForm.ParPopupMenuPopup(Sender: TObject);
begin
  PasteParItem.Enabled := ClipboardHasText;
  EditParItem.Enabled := ParGrid.Col <> 2;
  ConverttoPerturbationItem.Visible := (CurrentMNode is TState) or (CurrentMNode is TNucleus);
  MatrixElementsItem.Visible := ConverttoPerturbationItem.Visible;
  AddAllLevelsItem.Visible := (CurrentMNode is TManifold) or (CurrentMNode is TState);
  RemoveAllParametersItem.Visible := (CurrentMNode is TManifold) or (CurrentMNode is TMNodeWithExprs);
  RemoveParameterItem.Visible := RemoveAllParametersItem.Visible;
  if WheelAdjustActive then
    TurnonMouseAdjustItem.Caption := '&Turn off Mouse Adjust'
  else
    TurnonMouseAdjustItem.Caption := '&Turn on Mouse Adjust';
  AbortMouseAdjustItem.Visible := WheelAdjustActive;
  ResetMenu(nInitialParMenuItems, ParPopupMenu);
  CurrentMNode.AddHandlersToMenu(ParPopupMenu.Items);
end;

procedure TConstantsForm.ClearParItemClick(Sender: TObject);
begin
  BeginGlobalUpdate;
  try
    ParGrid.ClearSelection;
  finally
    EndGlobalUpdate;
  end;
end;

procedure TConstantsForm.OptPopupMenuPopup(Sender: TObject);
begin
  OptPasteItem.Enabled := ClipboardHasText;
  // EditParItem.Enabled := ParGrid.Col <> 2;
end;

procedure TConstantsForm.OptPasteItemClick(Sender: TObject);
begin
  OptGrid.PasteFromClipboard;
end;

procedure TConstantsForm.OptClearItemClick(Sender: TObject);
var
  r: Longint;
begin
  with OptGrid do
    if EditorMode then
      OptGrid.ClearSelection
    else
      for r := Selection.Top to Selection.Bottom do
        CurrentMNode.SetSettingFromStr(r+1,CurrentMNode.DefaultSettings[r+1]);
end;

procedure TConstantsForm.OptCopyItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard;
end;

procedure TConstantsForm.OptCopyWithLabelsItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard(True);
end;

procedure TConstantsForm.OptCutItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard;
  OptClearItemClick(Sender);
end;

procedure TConstantsForm.OptEditItemClick(Sender: TObject);
begin
  OptGrid.EditorMode := True;
end;

{ TCorrelationsHelper }

procedure TCorrelationsHelper.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  UpdateCorrelation(ConstantsForm.CurrentMNode as TCorrelations);
end;

procedure TCorrelationsHelper.ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean);
begin
  inherited ParGridChangeCellQuery(Col, Row, CanChange);
  CanChange := CanChange and (Row <> Col);
end;

procedure TCorrelationsHelper.ParGridChanged(Col, Row: Integer);
begin
  if Row > 0 then
    with ConstantsForm do
      if Row = Col then
        ParGrid[Col,Row] := 1
      else begin
        if (Row > 0) and (Col > 0) then begin
          if Row > Col then
            TCorrelations(CurrentMNode).FitDetails.Correlation[Row-1,Col-1] := ParGrid[Row, Col];
          if ParGrid[Col,Row] <> ParGrid[Row,Col] then
            ParGrid[Col,Row] := ParGrid[Row,Col];
        end;
      end;
end;

procedure TCorrelationsHelper.ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean);
begin
  IsFlag := False;
end;

procedure TCorrelationsHelper.ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean);
begin
  {}
end;

procedure TCorrelationsHelper.SetupGrid(MNode: TMNode);
begin
  UpdateCorrelation(TCorrelations(MNode));
  ConstantsForm.CurrentMNode := MNode;
end;

procedure TCorrelationsHelper.SetWidths;
begin
  inherited;
  ConstantsForm.ParGrid.AutoAdjustColumn(1,True);
end;

procedure TCorrelationsHelper.UpdateAction;
begin
  with ConstantsForm do
    if (CurrentMNode as TCorrelations).nEntries+1 <> ParGrid.RowCount then
      UpdateCorrelation(TCorrelations(CurrentMNode));
end;

procedure TCorrelationsHelper.UpdateCorrelation(Correlations: TCorrelations);
  function NameOf(MNode: TMNode; Index: Integer):string;
  begin
    Result := MNode.FullHeirarchicName+'.'+MNode.ParameterNames[Index];
    Delete(Result,1,Length(MNode.RootNode.FullHeirarchicName)+1);
  end;
var
  i, j, n: Integer;
  s: string;
begin
  { Allow for inconsistent value of n during update }
  n := Correlations.nEntries;
  with ConstantsForm do
    if n = 0 then
      EmptyParGrid
    else begin
      ParGrid.Enabled := True;
      ParGrid.RowCount := n+1;
      ParGrid.FixedRows := 1;
      ParGrid.ColCount := ParGrid.RowCount;
      for i := 0 to n - 1 do begin
        s := Correlations.EntryName(i,False);
        ParGrid.Lbl[i+1] := s;
        ParGrid.Title[i+1] := s;
        for j := 0 to i - 1 do begin
          ParGrid[i+1,j+1] := Correlations.FitDetails.Correlation[i,j];
          ParGrid[j+1,i+1] := Correlations.FitDetails.Correlation[i,j];
        end;
        ParGrid[i+1,i+1] := 1;
      end;
      ParGrid.AutoAdjustColumn(1);
    end;
end;

{ TInterpolatedPartitionFunctionHelper }

function TInterpolatedPartitionFunctionHelper.ExtraParRows: Integer;
begin
  Result := Length((ConstantsForm.CurrentMNode as TInterpolatedPartitionFunction).Plot.Frequency);
end;

procedure TInterpolatedPartitionFunctionHelper.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  with ConstantsForm do
    if MNode = CurrentMNode then begin
      if Index <= MNode.nParameters then begin
        ParGrid.Lbl[Index] := MNode.ParameterNames[Index];
        ParGrid.Valid[Index,1] := False;
        ParGrid[Index,2] := MNode.Parameters[Index];
      end;
    end;
end;

procedure TInterpolatedPartitionFunctionHelper.ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean);
begin
  inherited;
  CanChange := CanChange and ((Col = 2) or (Row > ConstantsForm.CurrentMNode.nParameters));
end;

procedure TInterpolatedPartitionFunctionHelper.ParGridChanged(Col, Row: Integer);
var
  PF: TInterpolatedPartitionFunction;
begin
  with ConstantsForm do
    if (Row <= CurrentMNode.nParameters) and (Col = 2) then
      inherited ParGridChanged(1, Row)
    else if Row > CurrentMNode.nParameters then begin
      PF := CurrentMNode as TInterpolatedPartitionFunction;
      case Col of
        1: PF.Plot.Frequency[Row-CurrentMNode.nParameters-1] := ParGrid[Row, Col];
        2: PF.Plot.Intensity[Row-CurrentMNode.nParameters-1] := ParGrid[Row, Col];
      end;
    end;
end;

procedure TInterpolatedPartitionFunctionHelper.ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean);
begin
  IsFlag := False;
end;

procedure TInterpolatedPartitionFunctionHelper.ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean);
begin
  with ConstantsForm do
    if ARow <= CurrentMNode.nParameters then
      inherited ParGridSelectCell(1,ARow,CanSelect)
    else
      case ACol of
        1: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Temperature/K';
        2: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Partition function at the given temperature';
      end;
end;

procedure TInterpolatedPartitionFunctionHelper.SetupGrid(MNode: TMNode);
var
  PF: TInterpolatedPartitionFunction;
  i: Integer;
begin
  with ConstantsForm do begin
    PF := MNode as TInterpolatedPartitionFunction;
    ParGrid.Enabled := True;
    ParGrid.RowCount := Length(PF.Plot.Frequency)+MNode.nParameters+1;
    ParGrid.FixedRows := 1;
    ParGrid.ColCount := 3;
    ParGrid.Title[1] := 'T';
    ParGrid.Title[2] := 'Value';
    CurrentMNode := MNode;
    for i := 1 to MNode.nParameters do
      ParameterChanged(MNode, i);
    for i := MNode.nParameters+1 to ParGrid.RowCount-1 do begin
      ParGrid.Lbl[i] := IntToStr(i-2);
      ParGrid[i,1] := PF.Plot.Frequency[i-3];
      ParGrid[i,2] := PF.Plot.Intensity[i-3];
    end;
  end;
end;

procedure TInterpolatedPartitionFunctionHelper.SetWidths;
begin
  with ConstantsForm do begin
    ParGrid.ColWidths[0] := OptGrid.ColWidths[0];
    ParGrid.AutoAdjustColumn(0,True);
    ParGrid.ColWidths[1] := OptGrid.ColWidths[1];
    ParGrid.ColWidths[2] := OptGrid.ColWidths[1];
  end;
end;

procedure TInterpolatedPartitionFunctionHelper.UpdateAction;
begin
  inherited;
end;

{ TTableHelper }

procedure TTableHelper.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  UpdateTable(ConstantsForm.CurrentMNode as TTable);
end;

procedure TTableHelper.ParGridChangeCellQuery(Col, Row: Integer; var CanChange: Boolean);
begin
  inherited ParGridChangeCellQuery(Col, Row, CanChange);
end;

procedure TTableHelper.ParGridChanged(Col, Row: Integer);
begin
  with ConstantsForm do
    if (Row > 0) and (Col > 0) then
      TTable(CurrentMNode).Values[Row-1,Col-1] := ParGrid[Row, Col];
end;


procedure TTableHelper.ParGridGetCellIsFlag(Col, Row: Integer; var IsFlag: Boolean);
begin
  IsFlag := False;
end;


procedure TTableHelper.ParGridSelectCell(ACol, ARow: Integer; var CanSelect: Boolean);
begin
  {}
end;


procedure TTableHelper.SetupGrid(MNode: TMNode);
begin
  UpdateTable(MNode as TTable);
  ConstantsForm.CurrentMNode := MNode;
end;


procedure TTableHelper.SetWidths;
var
  i: Integer;
begin
  with ConstantsForm do
    for i := 0 to ParGrid.ColCount-1 do      
      ParGrid.AutoAdjustColumn(i,i<>0,i=0);
end;


procedure TTableHelper.UpdateAction;
begin
  with ConstantsForm do
    if Length((CurrentMNode as TTable).Values)+1 <> ParGrid.RowCount then
      UpdateTable(TTable(CurrentMNode));
end;


procedure TTableHelper.UpdateTable(Table: TTable);
var
  n, i, j, nv: Integer;
begin
  { Allow for inconsistent value of n during update }
  n := Length(Table.Values);
  with ConstantsForm do
    if n = 0 then
      EmptyParGrid
    else begin
      ParGrid.Enabled := True;
      ParGrid.RowCount := n+1;
      ParGrid.FixedRows := 1;
      nv := Length(Table.ColumnNames);
      ParGrid.ColCount := nv+1;
      for i := 1 to nv do
        ParGrid.Title[i] := Table.ColumnNames[i-1];
      for i := 0 to n - 1 do begin
        ParGrid.Lbl[i+1] := IntToStr(i+1);
        for j := 0 to nv-1 do
          ParGrid[i+1,j+1] := Table.Values[i][j];
      end;
    end;
end;

end.
