unit FitControlFrm;
{$I utils.inc}{Copyright (C) 2014 C M Western; see commandline.pas for license}
interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type

  { TFitControlForm }

  TFitControlForm = class(TForm)
    CancelButton: TButton;
    PromptLabel: TLabel;
    CurrentButton: TButton;
    BelowButton: TButton;
    GlobalButton: TButton;
    ScaleEdit: TEdit;
    procedure FormClose(Sender: TObject; var AnAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  public
    Scale: Double;
    procedure SetUp(Base, Current: TObject; ACaption: string);
  end;

var
  FitControlForm: TFitControlForm;

implementation

uses Global;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TFitControlForm.FormClose(Sender: TObject; var AnAction: TCloseAction);
begin
  if Trim(ScaleEdit.Text) = '' then
    ScaleEdit.Text := '0.001'; { Reset to default }
  if not TryStrToFloat(ScaleEdit.Text, Scale) then begin
    AnAction := caNone;
    ShowInfo('Bad number:'+ScaleEdit.Text);
  end;
end;

procedure TFitControlForm.FormShow(Sender: TObject);
begin
  Width := CancelButton.Left + CancelButton.Width + GlobalButton.Left;
  Height := GlobalButton.Top + GlobalButton.Height + GlobalButton.Left;
end;

procedure TFitControlForm.SetUp(Base, Current: TObject; ACaption: string);
begin
  if Base = nil then
    GlobalButton.Enabled := False
  else begin
    GlobalButton.Enabled := True;
    GlobalButton.Caption := Copy(Base.ClassName,2,255);
  end;
  ScaleEdit.Visible := Current = nil;
  if Current = nil then begin
    PromptLabel.Caption := '&Scale factor from standard deviation:';
    Caption := ACaption;
  end else begin
    PromptLabel.Caption := ACaption;
    Caption := 'Fit Control';
  end;
  {$IFDEF FPC}
  OnActivate := @FormShow; { Needs to be called after all autosizing done }
  {$ENDIF}
end;

end.
