unit PDFStream;

{$H+}

interface              

uses Classes, SysUtils;

type

  { TPDFStreamg }

  TPDFStream = class(TStream)
    Stream: TStream;
    Eof: Boolean;
    function NextByte: Byte; virtual; abstract;
    function Read(var Buffer; Count: Longint): Longint; override;
    function RawByte: Byte;
    constructor Create(AStream: TStream);
    destructor Destroy; override;
  end;

implementation

{ TPDFStream }

function TPDFStream.Read(var Buffer; Count: Longint): Longint;
var
  P: PByte;
begin
  Result := 0;
  P := @Buffer;
  while (Count > 0) and not Eof do begin
    P^ := NextByte;
    if not Eof then
      Inc(Result);
    Dec(Count);
    Inc(P);
  end;
end;

function TPDFStream.RawByte: Byte;
begin
  if Stream.Read(Result,1) <> 1 then
    raise Exception.Create('PDF:Unexpected end of stream');
end;

constructor TPDFStream.Create(AStream: TStream);
begin
  inherited Create;
  Stream := AStream;
  Eof := False;
end;

destructor TPDFStream.Destroy;
begin
  if Stream is TPDFStream then
    FreeAndNil(Stream);
  inherited Destroy;
end;

end.

