program pgopher;

{$mode objfpc}{$H+}

uses
  //heaptrc,
  {$IFDEF UNIX} cthreads, {$ENDIF}
  Classes, f2c, Lapack,
  {$IFDEF MSWINDOWS} LResources, {$ENDIF}
  Interfaces, SysUtils, Forms, Mixture, SymT, Main, LogUnit, LineFrm, StateInfo,
  DrvLoader, JDXLoader, ConstFrm, TranInfo, CommandLine, OAsymT, RenForm,
  CheckPgopher, HundA, Progress, ExpBitmap, ExpPlot, LineOpt,
  ResidFrm, Global, MNodeClip, ReadBinary, printer4lazarus, Obs, ImportCALPGM,
  Hitran, PlotFrm, LineExportOpt, Fitter, CalFrm, ApplyFrm, SmoothDlg, PickDest,
  lutils, lforms, ImportJB95, PartFunc, Vib, LevelPlotter, LevelFrm,
  ExternalList, CheckImport, SimpleQnos, zMatrixFrm, InternalCoordsFrm,
  InternalCoords, ExoMol, CompressDlg, LoomisWood, LoomisWoodFrm, Peaks,
  VibPlotFrm, VibGridFrm, LmatrixBaseFrm, LmatrixFrm, SymmetryCoordsFrm,
  CartesianDisplacementsFrm, DushinskyFrm, FitControlFrm, FixForm;

{$R Pgopher.res}
{$IFDEF MSWINDOWS}
var
  IconResource: TLResource;
  IconStream: TStringStream;
{$ENDIF}
begin
  Application.Initialize;
  Application.Title:='Pgopher';
  Application.UpdateFormatSettings:=False;
  DecimalSeparator := '.';
  if GetAllOnTaskBarMode then
    Application.TaskBarBehavior := tbMultiButton
  else
    Application.TaskBarBehavior := tbSingleButton;
  {$IFDEF MSWINDOWS}
  IconStream := nil;
  try
    IconResource := LazarusResources.Find('PGOPHER','ICO');
    if Assigned(IconResource) then begin
      IconStream := TStringStream.Create(IconResource.Value);
      Application.Icon.LoadFromStream(IconStream);
    end;
  except
  end;
  IconStream.Free;
  {$ENDIF}
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TConstantsForm, ConstantsForm);
  Application.CreateForm(TRenameForm, RenameForm);
  Application.CreateForm(TStatesForm, StatesForm);
  Application.CreateForm(TTransitionForm, TransitionForm);
  Application.CreateForm(TProgressForm, ProgressForm);
  Application.CreateForm(TLineExportOptions, LineExportOptions);
  Application.CreateForm(TBinaryImportDlg, BinaryImportDlg);
  Application.CreateForm(TCalForm, CalForm);
  Application.CreateForm(TApplyForm, ApplyForm);
  Application.CreateForm(TSmoothForm, SmoothForm);
  Application.CreateForm(TPickDestForm, PickDestForm);
  Application.CreateForm(TLineFrmOptDlg, LineFrmOptDlg);
  Application.CreateForm(TLineForm, LineForm);
  Application.CreateForm(TResidualForm, ResidualForm);
  Application.CreateForm(TLoomisWoodForm, LoomisWoodForm);
  Application.CreateForm(TFitControlForm, FitControlForm);
  LevelForm := TLevelPlotter.Create(Application); { Slightly non-standard usage }
  HandleCommandLine;
  Application.Run;
end.

