unit ImageMod;

{ Contains standard image list for use by TextWin, GraphWin and others }

interface
{$I utils.inc}{ Copyright (C) 2005 C M Western; see PcontrolsReg.pas for license}
uses
  Classes,
  {$IFNDEF CLX_} Controls, Forms, ImgList;
  {$ELSE} QImgList; {$ENDIF}

type
  TImageModule = class(TDataModule)
    ImageList: TImageList;
    procedure DataModuleCreate(Sender: TObject);
  end;

var
  ImageModule: TImageModule;

implementation

uses {$IFDEF LCL_} LResources, {$ENDIF} SysUtils, Graphics;

{$IFNDEF FPC}
{$R *.dfm}
{$R imagemod.dcr}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TImageModule.DataModuleCreate(Sender: TObject);
{$IFDEF LCL_}
var
  AllP: TPicture;
  All: TRasterImage;
  One: TBitmap;
  i: Integer;
{$ENDIF}
begin
{$IFDEF VCL_}
  ImageList.Clear;
  ImageList.ResourceLoad(rtBitmap, 'IMAGEMOD', clFuchsia);
{$ENDIF}
{$IFDEF LCL_}
  AllP := TPicture.Create;
  AllP.LoadFromLazarusResource('ImageMod');
  if AllP.Graphic is TRasterImage then
    All := AllP.Graphic as TRasterImage
  else
    raise Exception.Create('Imagemod');
  One := TBitmap.Create;
  for i := 0 to (All.Width div All.Height) - 1 do begin
    One.Height := All.Height;
    One.Width := One.Height;
    All.Canvas.CopyRect(Rect(0, i*One.Height, One.Width, (i+1)*One.Height),
                        One.Canvas, Rect(0, 0, One.Width, One.Height));
    ImageList.Add{Direct}(One, nil);
  end;
  AllP.Free;
  One.Free;
{$ENDIF}
end;

{$IFDEF LCL_}
initialization
  {$I ImageModXPM.lrs}
{$ENDIF}
end.
