unit PcontrolsReg;

{$I utils.inc}
{
Pcontrols - utility controls for pgopger
Copyright (C) 2005-15 C M Western
School of Chemistry, University of Bristol, Bristol, UK
For further information please see http://pgopher.chm.bris.ac.uk/
or contact help-pgopher@bristol.ac.uk

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
}

interface

procedure Register;

implementation

uses {$IFDEF VCL_} MakeHelp, {$IF CompilerVersion >= 24} System.Actions, {$IFEND} {$ENDIF}
     {$IFDEF LCL_} LResources, {$ELSE} FileNameEdit, {$ENDIF}
     Classes, ActnList, ToolBarEx, LogControl, EditLog, Handles,
     PrintPre, LogFind, ExActn, LogActn, TextPre, MarkChse, PenChse,
     Graphs, GPenDlg, GMarkDlg, Split, AlEdit, GridEx, NewSpin, NGrid,
     ProjAbout, CompatMsg, FormGrid, MDIHelp, MDIFix, QuantumSpin,
     FxFntDlg, TextActn, Recent;

{ Shifted: ,DirEdit,  TDirEdit   $I DirEdit.lrs}
{ , PropStor   TPropStorage   $I PropStor.lrs}
{ $I FileNameEdit.lrs}

{$IFDEF VCL_}
{$IFNDEF VER80}
{$R Graphs.d32}
{$R GPenDlg.d32}
{$R PenChse.d32}
{$R GMarkDlg.d32}
{$R MarkChse.d32}
{}
{$R Handles.d32}
{$R MuScroll.d32}
{$ELSE}
{$R Graphs.d16}
{$R Gpendlg.d16}
{$R PenChse.d16}
{$R Gmarkdlg.d16}
{$R MarkChse.d16}
{}
{$R Handles.d16}
{$R Muscroll.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R AlEdit.d32}
{$ELSE}
{$R AlEdit.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R PrintPre.d32}
{$ELSE}
{$R PrintPre.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R LogDlg.d32}
{$ELSE}
{$R LogDlg.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R Split.d32}
{$ELSE}
{$R Split.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R Log.d32}
{$R EditLog.d32}
{$ELSE}
{$R Log.d16}
{$R EditLog.d16}
{$ENDIF}

{$IFNDEF VER80}
{$IFNDEF FPC}
{$R ProjIDE.d32}
{$ENDIF}
{$ELSE}
{$R ProjIDE.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R NGrid.d32}
{$ELSE}
{$R NGrid.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R FileNameEdit.d32}   
{$ELSE}              
{$R FileNameEdit.d16}         
{$ENDIF}

{$IFNDEF VER80}
{$R FormGrid.d32}
{$ELSE}
{$R FormGrid.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R MDIHelp.d32}
{$ELSE}
{$R MDIHelp.d16}
{$ENDIF}

{$IFNDEF VER80}
{$R FxFntDlg.d32}
{$ELSE}
{$R FxFntDlg.d16}
{$ENDIF}

{$ENDIF}

procedure Register;
begin

  { Supporting components }
  {$IFDEF VCL_}
  RegisterComponents('Pgopher', [TMakeHelpButton]);
  {$ENDIF}
  {$IFNDEF LCL_}
  RegisterComponents('Pgopher', [TFileNameEdit]);
  {$ENDIF}

  RegisterComponents('Pgopher', [TToolBarEx, TToolButtonEx, TLog, TEditLog, TRecentFiles, TStretchHandle, TPrintPreview]);
  RegisterComponents('Pgopher', [TTextPrintPreview, TLogFindDialog, TLogReplaceDialog]);
  RegisterActions('Edit', [TExUndo, TExRedo, TExCut, TExCopy, TExPaste, TExClear, TExSelectAll, TExPrint,
                           TExPrintPreview], nil);
  RegisterActions('Text', [TLogFind, TLogFindNext, TLogFindThisWord, TTextReplace,
                           TTextIncrement, TTextDecrement,
                           TTextRecordMacro, TTextPlayBackMacro, TTextSortUp, TTextSortDown,
                           TTextSetBookMark, TTextGoToBookMark, TTextExchangeWithBookMark, TTextGoToLine,
                           TTextRemoveTabs], nil);
  RegisterActions('Text', [TTextNew, TTextOpen, TTextSave, TTextSaveAll], nil);
  RegisterActions('Window', [TExWindowCascade, TExWindowTileHorizontal, TExWindowTileVertical, TExWindowArrange
                             {$IFDEF LCL_},TWindowMinimizeAll{$ENDIF}], nil);
  RegisterComponents('Pgopher', [TMarkChoose, TPenChoose, TGraphB, TGraphD, TGraphPenDialog, TGraphMarkDialog, TGraphPrintPreview]);
  RegisterComponents('Pgopher', [TSplit, TAlignedEdit, TStringGridEx, TProject, TMDIHelper,
                                 TSpinBox, TFixedSpin, TNumberGrid, TFormulaGrid, TCompatMsg, TQuantumSpin, TFixedFontDialog]);
end;

initialization
{$IFDEF LCL_}
  {$I AlEdit.lrs}
  {$I Log.lrs}
  {$I EditLog.lrs}
  {$I Handles.lrs}
  {$I PrintPre.lrs}
  {$I LogDlg.lrs}
  {$I Graphs.lrs}
// These two can't be included, because Lazarus does not allow two resources of the same
// name but different type
//  {$I MarkChseIcon.lrs}
//  {$I PenChseIcon.lrs}
  {$I GMarkDlg.lrs}
  {$I GPenDlg.lrs}
  {$I NGrid.lrs}
  {$I Split.lrs}
  {$I ToolBarEx.lrs}
  {$I ProjIDE.lrs}
// ? Needed  {$I MuScroll.lrs}
{$ENDIF}
end.

